"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactGroup = _interopRequireDefault(require("react-group"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Markdown = _interopRequireDefault(require("../Markdown"));

var _Name = _interopRequireDefault(require("../Name"));

var _Type = _interopRequireDefault(require("../Type"));

var _this = void 0;

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-argument-margin': '0 0 8px 0'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Display argument name. */
  name: _propTypes.default.string,

  /** Display argument type name. */
  type: _propTypes.default.object,

  /** Default value. */
  default: _propTypes.default.string,

  /** Display argument description. */
  description: _propTypes.default.string,

  /** Toggle returns and display string "Returns". */
  returns: _propTypes.default.bool,

  /** Toggle block style. */
  block: _propTypes.default.bool,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-argument-margin': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var ArgumentRendererUnstyled = function ArgumentRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      name = _omit.name,
      description = _omit.description,
      returns = _omit.returns,
      block = _omit.block,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "name", "description", "returns", "block", "cssModule"]);

  var type = _this.props.type;
  var isOptional = type && type.type === 'OptionalType';
  var defaultValue = props.default;

  if (isOptional) {
    type = type.expression;
  }

  return _react.default.createElement(_reactGroup.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-argument', {
      block: block
    }), cssModule)
  }, attributes), returns && 'Returns', name && _react.default.createElement("span", null, _react.default.createElement(_Name.default, null, name), type && ':'), type && _react.default.createElement(_Type.default, null, type.name, isOptional && '?', !!defaultValue && "=".concat(defaultValue)), type && description && ' — ', description && _react.default.createElement(_Markdown.default, {
    text: "".concat(description),
    inline: true
  }));
};

ArgumentRendererUnstyled.defaultProps = defaultProps;
ArgumentRendererUnstyled.propTypes = propTypes;
var ArgumentRenderer = (0, _styledComponents.default)(ArgumentRendererUnstyled).withConfig({
  displayName: "ArgumentRenderer",
  componentId: "sc-1xad1il-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-argument.block {\n      font-size: ".concat(props.theme.styleguide['$rsg-argument-margin'], ";\n    }\n ");
});
ArgumentRenderer.defaultProps = defaultProps;
ArgumentRenderer.propTypes = propTypes;
/** @component */

var _default = ArgumentRenderer;
exports.default = _default;