"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Argument = _interopRequireDefault(require("../Argument"));

var _Heading = _interopRequireDefault(require("../Heading"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-arguments-margin': '0 0 8px 0',
      '$rsg-arguments-font-size': 'inherit',
      '$rsg-arguments-heading-margin': '0 0 4px 0'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Arguments name, type and description passed to `<Argument />` component. Can be: */
  args: _propTypes.default.arrayOf(_propTypes.default.shape({
    name: _propTypes.default.string.isRequired,
    type: _propTypes.default.object,
    description: _propTypes.default.string
  })).isRequired,

  /** Toggle heading style. */
  heading: _propTypes.default.bool,
  // eslint-disable-line react/require-default-props  /** Theme variables. Can be: */

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-arguments-margin': _propTypes.default.string,
      '$rsg-arguments-font-size': _propTypes.default.string,
      '$rsg-arguments-heading-margin': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var ArgumentsRendererUnstyled = function ArgumentsRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      args = _omit.args,
      heading = _omit.heading,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "args", "heading", "cssModule"]);

  if (args.length === 0) {
    return null;
  }

  return _react.default.createElement("div", (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-arguments'), cssModule)
  }, attributes), heading && _react.default.createElement("div", null, _react.default.createElement(_Heading.default, {
    className: "rsg-arguments-heading",
    level: 5
  }, "Arguments")), args.map(function (arg) {
    return _react.default.createElement(_Argument.default, (0, _extends2.default)({
      key: arg.name
    }, arg));
  }));
};

ArgumentsRendererUnstyled.defaultProps = defaultProps;
ArgumentsRendererUnstyled.propTypes = propTypes;
var ArgumentsRenderer = (0, _styledComponents.default)(ArgumentsRendererUnstyled).withConfig({
  displayName: "ArgumentsRenderer",
  componentId: "fsshd1-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-arguments {\n      margin: ".concat(props.theme.styleguide['$rsg-arguments-margin'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-arguments-font-size'], ";\n      .rsg-arguments-heading {\n        margin: ").concat(props.theme.styleguide['$rsg-arguments-heading-margin'], ";\n      }\n    }\n ");
});
ArgumentsRenderer.defaultProps = defaultProps;
ArgumentsRenderer.propTypes = propTypes;
/** @component */

var _default = ArgumentsRenderer;
exports.default = _default;