"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Code = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Code"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-code-font-family': 'SF Mono, Monaco, "Inconsolata", "Fira Code", "Fira Mono", "Droid Sans Mono", Consolas, "Roboto Mono", "Source Code Pro", monospace',
      '$rsg-code-font-size': 'inherit',
      '$rsg-code-word-wrap': 'break-word',
      '$rsg-code-padding': '0',
      '$rsg-code-color': '#B31255',
      '$rsg-code-background': 'transparent',
      '$rsg-code-white-space': 'inherit',
      '$rsg-code-highlight-font-family': 'SF Mono, Monaco, "Inconsolata", "Fira Code", "Fira Mono", "Droid Sans Mono", Consolas, "Roboto Mono", "Source Code Pro", monospace',
      '$rsg-code-highlight-font-size': 'inherit',
      '$rsg-code-highlight-word-wrap': 'break-word',
      '$rsg-code-highlight-padding': '0',
      '$rsg-code-highlight-color': 'inherit',
      '$rsg-code-highlight-background': 'transparent',
      '$rsg-code-highlight-white-space': 'inherit'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /**
   * @ignore
   */
  children: _propTypes.default.node.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-code-font-family': _propTypes.default.string,
      '$rsg-code-font-size': _propTypes.default.string,
      '$rsg-code-word-wrap': _propTypes.default.string,
      '$rsg-code-padding': _propTypes.default.string,
      '$rsg-code-color': _propTypes.default.string,
      '$rsg-code-background': _propTypes.default.string,
      '$rsg-code-white-space': _propTypes.default.string,
      '$rsg-code-highlight-font-family': _propTypes.default.string,
      '$rsg-code-highlight-font-size': _propTypes.default.string,
      '$rsg-code-highlight-word-wrap': _propTypes.default.string,
      '$rsg-code-highlight-padding': _propTypes.default.string,
      '$rsg-code-highlight-color': _propTypes.default.string,
      '$rsg-code-highlight-background': _propTypes.default.string,
      '$rsg-code-highlight-white-space': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var CodeRendererUnstyled = function CodeRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "cssModule"]);

  var isHighlighted = className && className.indexOf('lang-') !== -1;

  if (isHighlighted) {
    return _react.default.createElement(_Code.default, {
      className: (0, _classnames.default)(className, 'rsg-code-highlight'),
      dangerouslySetInnerHTML: {
        __html: children
      }
    });
  }

  return _react.default.createElement(_Code.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-code'), cssModule)
  }, attributes), children);
};

CodeRendererUnstyled.defaultProps = defaultProps;
CodeRendererUnstyled.propTypes = propTypes;
var CodeRenderer = (0, _styledComponents.default)(CodeRendererUnstyled).withConfig({
  displayName: "CodeRenderer",
  componentId: "tsp6zy-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-code {\n      font-family: ".concat(props.theme.styleguide['$rsg-code-font-family'], ";\n      word-wrap: ").concat(props.theme.styleguide['$rsg-code-word-wrap'], ";\n      padding: ").concat(props.theme.styleguide['$rsg-code-padding'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-code-font-size'], ";\n      color: ").concat(props.theme.styleguide['$rsg-code-color'], ";\n      background: ").concat(props.theme.styleguide['$rsg-code-background'], ";\n      white-space: ").concat(props.theme.styleguide['$rsg-code-white-space'], ";\n    }\n    &.rsg-code-highlight {\n      font-family: ").concat(props.theme.styleguide['$rsg-code-highlight-font-family'], ";\n      word-wrap: ").concat(props.theme.styleguide['$rsg-code-highlight-word-wrap'], ";\n      padding: ").concat(props.theme.styleguide['$rsg-code-highlight-padding'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-code-highlight-font-size'], ";\n      color: ").concat(props.theme.styleguide['$rsg-code-highlight-color'], ";\n      background: ").concat(props.theme.styleguide['$rsg-code-highlight-background'], ";\n      white-space: ").concat(props.theme.styleguide['$rsg-code-highlight-white-space'], ";\n    }\n ");
});
CodeRenderer.defaultProps = defaultProps;
CodeRenderer.propTypes = propTypes;
/** @component */

var _default = CodeRenderer;
exports.default = _default;