"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _BootstrapProvider = _interopRequireDefault(require("@bootstrap-styled/provider/lib/BootstrapProvider"));

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _CodeRenderer = _interopRequireWildcard(require("../CodeRenderer"));

/* eslint-disable */

/**
 * Testing our CodeRenderer component
 */
var children = _react.default.createElement("h1", null, "Test");

describe('<CodeRenderer />', function () {
  var theme = _CodeRenderer.defaultProps.theme;
  it('should render an ComponentListRenderer with theme', function () {
    var renderedComponent = (0, _enzyme.mount)(_react.default.createElement(_BootstrapProvider.default, {
      theme: theme,
      injectGlobal: false
    }, _react.default.createElement(_CodeRenderer.default, _CodeRenderer.defaultProps, children)));
    expect(renderedComponent.find('CodeRendererUnstyled').length).toEqual(1);
  });
  it('should render an ComponentListRenderer with children', function () {
    var renderedComponent = (0, _enzyme.mount)(_react.default.createElement(_BootstrapProvider.default, {
      theme: theme,
      injectGlobal: false
    }, _react.default.createElement(_CodeRenderer.default, _CodeRenderer.defaultProps, children)));
    expect(renderedComponent.contains(children)).toEqual(true);
  });
  it('should render an ComponentListRenderer with dangerouslySetInnerHTML children and lang-js classname', function () {
    var renderedComponent = (0, _enzyme.mount)(_react.default.createElement(_BootstrapProvider.default, {
      theme: theme,
      injectGlobal: false
    }, _react.default.createElement(_CodeRenderer.default, (0, _extends2.default)({}, _CodeRenderer.defaultProps, {
      className: "lang-js"
    }), children)));
    expect(renderedComponent.find('Code').props().hasOwnProperty('dangerouslySetInnerHTML')).toBe(true);
    expect(renderedComponent.find('Code').hasClass('lang-js')).toBe(true);
  });
});