"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lodash = _interopRequireDefault(require("lodash.debounce"));

var _reactCodemirror = require("react-codemirror2");

var _lodash2 = _interopRequireDefault(require("lodash.omit"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

require("codemirror/mode/jsx/jsx");

require("codemirror/lib/codemirror.css");

require("rsg-codemirror-theme.css");

var UPDATE_DELAY = 10;
var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-editor-code-mirror-isolation': false,
      '$rsg-editor-code-mirror-font-family': 'Consolas, "Liberation Mono", Menlo, monospace',
      '$rsg-editor-code-mirror-height': 'auto',
      '$rsg-editor-code-mirror-padding': '4px 8px',
      '$rsg-editor-code-mirror-font-size': '13px',
      '$rsg-editor-code-mirror-pre-isolation': false,
      '$rsg-editor-code-mirror-pre-padding': '0',
      '$rsg-editor-code-mirror-scroll-isolation': false,
      '$rsg-editor-code-mirror-scroll-height': 'auto',
      '$rsg-editor-code-mirror-scroll-overflow-y': 'hidden',
      '$rsg-editor-code-mirror-scroll-overflow-x': 'auto',
      '$rsg-editor-code-mirror-cm-error-isolation': false,
      '$rsg-editor-code-mirror-cm-error-background': 'none'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props
  code: _propTypes.default.string.isRequired,
  onChange: _propTypes.default.func.isRequired,
  editorConfig: _propTypes.default.object,
  // eslint-disable-line react/require-default-props

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-editor-code-mirror-isolation': _propTypes.default.bool,
      '$rsg-editor-code-mirror-font-family': _propTypes.default.string,
      '$rsg-editor-code-mirror-height': _propTypes.default.string,
      '$rsg-editor-code-mirror-padding': _propTypes.default.string,
      '$rsg-editor-code-mirror-font-size': _propTypes.default.string,
      '$rsg-editor-code-mirror-pre-isolation': _propTypes.default.bool,
      '$rsg-editor-code-mirror-pre-padding': _propTypes.default.string,
      '$rsg-editor-code-mirror-scroll-isolation': _propTypes.default.bool,
      '$rsg-editor-code-mirror-scroll-height': _propTypes.default.string,
      '$rsg-editor-code-mirror-scroll-overflow-y': _propTypes.default.string,
      '$rsg-editor-code-mirror-scroll-overflow-x': _propTypes.default.string,
      '$rsg-editor-code-mirror-cm-error-isolation': _propTypes.default.bool,
      '$rsg-editor-code-mirror-cm-error-background': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var EditorUnstyled =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(EditorUnstyled, _Component);

  function EditorUnstyled() {
    var _this;

    (0, _classCallCheck2.default)(this, EditorUnstyled);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(EditorUnstyled).call(this));
    _this.handleChange = (0, _lodash.default)(_this.handleChange.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this))), UPDATE_DELAY);
    return _this;
  }

  (0, _createClass2.default)(EditorUnstyled, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return !!(this.getEditorConfig(nextProps).readOnly && nextProps.code !== this.props.code);
    }
  }, {
    key: "getEditorConfig",
    value: function getEditorConfig(props) {
      return (0, _objectSpread2.default)({}, this.context.config.editorConfig, props.editorConfig);
    }
  }, {
    key: "handleChange",
    value: function handleChange(editor, metadata, newCode) {
      var onChange = this.props.onChange;

      if (onChange) {
        onChange(newCode);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _omit = (0, _lodash2.default)(this.props, ['theme']),
          className = _omit.className,
          code = _omit.code,
          cssModule = _omit.cssModule,
          attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "code", "cssModule"]);

      return _react.default.createElement(_reactCodemirror.UnControlled, (0, _extends2.default)({
        className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-editor'), cssModule)
      }, attributes, {
        value: code,
        onChange: this.handleChange,
        options: this.getEditorConfig(this.props)
      }));
    }
  }]);
  return EditorUnstyled;
}(_react.Component);

(0, _defineProperty2.default)(EditorUnstyled, "propTypes", propTypes);
(0, _defineProperty2.default)(EditorUnstyled, "contextTypes", {
  config: _propTypes.default.object.isRequired
});
(0, _defineProperty2.default)(EditorUnstyled, "defaultProps", defaultProps);
var Editor = (0, _styledComponents.default)(EditorUnstyled).withConfig({
  displayName: "Editor",
  componentId: "fpi8rd-0"
})(["", ""], function (props) {
  return "\n    &.rsg-editor {\n      .CodeMirror.CodeMirror {\n        isolation: ".concat(props.theme.styleguide['$rsg-editor-code-mirror-isolate'], ";\n        font-family: ").concat(props.theme.styleguide['$rsg-editor-code-mirror-font-family'], ";\n        height: ").concat(props.theme.styleguide['$rsg-editor-code-mirror-height'], ";\n        padding: ").concat(props.theme.styleguide['$rsg-editor-code-mirror-padding'], ";\n        font-size: ").concat(props.theme.styleguide['$rsg-editor-code-mirror-font-size'], ";\n      }\n      .CodeMirror.CodeMirror pre {\n        isolation: ").concat(props.theme.styleguide['$rsg-editor-code-mirror-pre-isolate'], ";\n        padding: ").concat(props.theme.styleguide['$rsg-editor-code-mirror-pre-padding'], ";\n      }\n      .CodeMirror-scroll.CodeMirror-scroll {\n        isolation: ").concat(props.theme.styleguide['$rsg-editor-code-mirror-scroll-isolate'], ";\n        height: ").concat(props.theme.styleguide['$rsg-editor-code-mirror-scroll-height'], ";\n        overflow-y: ").concat(props.theme.styleguide['$rsg-editor-code-mirror-scroll-overflow-y'], ";\n        overflow-x: ").concat(props.theme.styleguide['$rsg-editor-code-mirror-scroll-overflow-x'], ";\n      }\n      .cm-error.cm-error {\n        isolation: ").concat(props.theme.styleguide['$rsg-editor-code-mirror-cm-error-isolate'], ";\n        background: ").concat(props.theme.styleguide['$rsg-editor-code-mirror-cm-error-'], ";\n      }\n    }\n ");
});
Editor.defaultProps = defaultProps;
Editor.propTypes = propTypes;
/** @component */

var _default = Editor;
exports.default = _default;