"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-editor-loader-padding': '2px 8px 2px 2px',
      '$rsg-editor-loader-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", Cantarell, "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif',
      '$rsg-editor-loader-font-size': '13px',
      '$rsg-editor-loader-color': '#767676',
      '$rsg-editor-loader-background-color': '#f5f5f5'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-editor-loader-padding': _propTypes.default.string,
      '$rsg-editor-loader-font-family': _propTypes.default.string,
      '$rsg-editor-loader-font-size': _propTypes.default.string,
      '$rsg-editor-loader-color': _propTypes.default.string,
      '$rsg-editor-loader-background-color': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var EditorLoaderRendererUnstyled = function EditorLoaderRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "cssModule"]);

  return _react.default.createElement("div", (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-editor-loader'), cssModule)
  }, attributes), "Loading\u2026");
};

EditorLoaderRendererUnstyled.defaultProps = defaultProps;
EditorLoaderRendererUnstyled.propTypes = propTypes;
var EditorLoaderRenderer = (0, _styledComponents.default)(EditorLoaderRendererUnstyled).withConfig({
  displayName: "EditorLoaderRenderer",
  componentId: "sc-1ob4sgp-0"
})(["", ""], function (props) {
  return "\n    &.rsg-editor-loader {\n      padding: ".concat(props.theme.styleguide['$rsg-editor-loader-padding'], ";\n      font-family: ").concat(props.theme.styleguide['$rsg-editor-loader-font-family'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-editor-loader-font-size'], ";\n      color: ").concat(props.theme.styleguide['$rsg-editor-loader-color'], ";\n      background-color: ").concat(props.theme.styleguide['$rsg-editor-loader-background-color'], " !important;\n    }\n ");
});
EditorLoaderRenderer.defaultProps = defaultProps;
EditorLoaderRenderer.propTypes = propTypes;
/** @component */

var _default = EditorLoaderRenderer;
exports.default = _default;