"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Pre = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Pre"));

var _P = _interopRequireDefault(require("@bootstrap-styled/v4/lib/P"));

var _A = _interopRequireDefault(require("@bootstrap-styled/v4/lib/A"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-error-margin': '8px',
      '$rsg-error-line-height': '1.2',
      '$rsg-error-font-size': '13px',
      '$rsg-error-stack-color': '#c00',
      '$rsg-error-stack-white-space': 'pre-wrap',
      '$rsg-error-stack-font-family': 'Consolas, "Liberation Mono", Menlo, monospace',
      '$rsg-error-message-color': '#c00',
      '$rsg-error-message-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Error will be displayed as a string. */
  error: _propTypes.default.object.isRequired,

  /** Info will be displayed as a string. */
  info: _propTypes.default.shape({
    componentStack: _propTypes.default.any.isRequired
  }).isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-error-margin': _propTypes.default.string,
      '$rsg-error-line-height': _propTypes.default.string,
      '$rsg-error-font-size': _propTypes.default.string,
      '$rsg-error-stack-color': _propTypes.default.string,
      '$rsg-error-stack-white-space': _propTypes.default.string,
      '$rsg-error-stack-font-family': _propTypes.default.string,
      '$rsg-error-message-color': _propTypes.default.string,
      '$rsg-error-message-font-family': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var ErrorRendererUnstyled = function ErrorRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      error = _omit.error,
      info = _omit.info,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "error", "info", "cssModule"]);

  return _react.default.createElement("div", (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-error'), cssModule)
  }, attributes), _react.default.createElement(_Pre.default, {
    className: "error-stack"
  }, error.toString(), info.componentStack.toString()), _react.default.createElement("div", {
    className: "error-message"
  }, _react.default.createElement(_P.default, null, "This may be due to an error in a component you are overriding, or a bug in React Styleguidist."), _react.default.createElement(_P.default, null, "If you believe this is a bug,\xA0", _react.default.createElement(_A.default, {
    style: {
      color: 'inherit'
    },
    href: "https://github.com/styleguidist/react-styleguidist/issues"
  }, "please submit an issue"), ".")));
};

ErrorRendererUnstyled.defaultProps = defaultProps;
ErrorRendererUnstyled.propTypes = propTypes;
var ErrorRenderer = (0, _styledComponents.default)(ErrorRendererUnstyled).withConfig({
  displayName: "ErrorRenderer",
  componentId: "sc-1pkj1i2-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-error {\n      margin: ".concat(props.theme.styleguide['$rsg-error-margin'], ";\n      line-height: ").concat(props.theme.styleguide['$rsg-error-line-height'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-error-font-size'], ";\n      .error-stack {\n        color: ").concat(props.theme.styleguide['$rsg-error-stack-color'], ";\n        white-space: ").concat(props.theme.styleguide['$rsg-error-stack-white-space'], ";\n        font-family: ").concat(props.theme.styleguide['$rsg-error-stack-font-family'], ";\n      }\n      .error-message {\n        color: ").concat(props.theme.styleguide['$rsg-error-message-color'], ";\n        font-family: ").concat(props.theme.styleguide['$rsg-error-message-font-family'], ";\n      }\n    }\n ");
});
ErrorRenderer.defaultProps = defaultProps;
ErrorRenderer.propTypes = propTypes;
/** @component */

var _default = ErrorRenderer;
exports.default = _default;