"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.ExamplePlaceholderRendererUnstyled = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Button = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Button"));

var _hover = require("@bootstrap-styled/css-mixins/lib/hover");

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var _consts = require("react-styleguidist/scripts/consts");

var _Markdown = _interopRequireDefault(require("../Markdown"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-example-placeholder-outline': 'none',
      '$rsg-example-placeholder-padding': '0',
      '$rsg-example-placeholder-font-size': '15px',
      '$rsg-example-placeholder-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif',
      '$rsg-example-placeholder-decoration': 'underline',
      '$rsg-example-placeholder-color': '#767676',
      '$rsg-example-placeholder-border': '0',
      '$rsg-example-placeholder-cursor': 'pointer',
      '$rsg-example-placeholder-background': 'transparent',
      '$rsg-example-placeholder-hover-isolate': 'false',
      '$rsg-example-placeholder-hover-color': '#ccc'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Component name used in example. */
  name: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-example-placeholder-outline': _propTypes.default.string,
      '$rsg-example-placeholder-padding': _propTypes.default.string,
      '$rsg-example-placeholder-font-size': _propTypes.default.string,
      '$rsg-example-placeholder-font-family': _propTypes.default.string,
      '$rsg-example-placeholder-decoration': _propTypes.default.string,
      '$rsg-example-placeholder-color': _propTypes.default.string,
      '$rsg-example-placeholder-border': _propTypes.default.string,
      '$rsg-example-placeholder-cursor': _propTypes.default.string,
      '$rsg-example-placeholder-backgound': _propTypes.default.string,
      '$rsg-example-placeholder-hover-isolate': _propTypes.default.string,
      '$rsg-example-placeholder-hover-color': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var ExamplePlaceholderRendererUnstyled =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(ExamplePlaceholderRendererUnstyled, _Component);

  function ExamplePlaceholderRendererUnstyled() {
    var _this;

    (0, _classCallCheck2.default)(this, ExamplePlaceholderRendererUnstyled);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ExamplePlaceholderRendererUnstyled).call(this));
    _this.handleOpen = _this.handleOpen.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    _this.state = {
      isVisible: false
    };
    return _this;
  }

  (0, _createClass2.default)(ExamplePlaceholderRendererUnstyled, [{
    key: "handleOpen",
    value: function handleOpen() {
      this.setState({
        isVisible: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _omit = (0, _lodash.default)(this.props, ['theme']),
          className = _omit.className,
          name = _omit.name,
          cssModule = _omit.cssModule,
          attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "name", "cssModule"]);

      var isVisible = this.state.isVisible;

      if (isVisible) {
        /* eslint-disable no-tabs */
        return _react.default.createElement(_Markdown.default, {
          text: "\nCreate **Readme.md** or **".concat(name, ".md** file in the component\u2019s folder like this:\n\n    ").concat(name, " example:\n\n    ```js\n    <").concat(name, " pizza=\"\uD83C\uDF55\" />\n\t```\n\nYou may need to **restart** the style guide server after adding an example file.\n\nRead more in the [documenting components guide](").concat(_consts.DOCS_DOCUMENTING, ").\n\t\t\t\t\t")
        });
        /* eslint-enable no-tabs */
      }

      return _react.default.createElement(_Button.default, (0, _extends2.default)({
        className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-example-placeholder'), cssModule)
      }, attributes, {
        onClick: this.handleOpen
      }), "Add examples to this component");
    }
  }]);
  return ExamplePlaceholderRendererUnstyled;
}(_react.Component);

exports.ExamplePlaceholderRendererUnstyled = ExamplePlaceholderRendererUnstyled;
(0, _defineProperty2.default)(ExamplePlaceholderRendererUnstyled, "propTypes", propTypes);
(0, _defineProperty2.default)(ExamplePlaceholderRendererUnstyled, "defaultProps", defaultProps);
var ExamplePlaceholderRenderer = (0, _styledComponents.default)(ExamplePlaceholderRendererUnstyled).withConfig({
  displayName: "ExamplePlaceholderRenderer",
  componentId: "z14yh3-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-example-placeholder {\n      outline: ".concat(props.theme.styleguide['$rsg-example-placeholder-outline'], " !important;\n      padding: ").concat(props.theme.styleguide['$rsg-example-placeholder-padding'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-example-placeholder-font-size'], ";\n      font-family: ").concat(props.theme.styleguide['$rsg-example-placeholder-font-family'], ";\n      text-decoration: ").concat(props.theme.styleguide['$rsg-example-placeholder-decoration'], ";\n      color: ").concat(props.theme.styleguide['$rsg-example-placeholder-color'], ";\n      border: ").concat(props.theme.styleguide['$rsg-example-placeholder-border'], ";\n      cursor: ").concat(props.theme.styleguide['$rsg-example-placeholder-cursor'], ";\n      background: ").concat(props.theme.styleguide['$rsg-example-placeholder-background'], ";\n   ").concat((0, _hover.hover)("\n      isolation: ".concat(props.theme.styleguide['$rsg-example-placeholder-hover-isolate'], ";\n      color: ").concat(props.theme.styleguide['$rsg-example-placeholder-hover-color'], ";\n    ")), "\n      &:active {\n        isolation: ").concat(props.theme.styleguide['$rsg-example-placeholder-hover-isolate'], ";\n        color: ").concat(props.theme.styleguide['$rsg-example-placeholder-hover-color'], ";\n      }\n    }\n ");
});
ExamplePlaceholderRenderer.defaultProps = defaultProps;
ExamplePlaceholderRenderer.propTypes = propTypes;
/** @component */

var _default = ExamplePlaceholderRenderer;
exports.default = _default;