"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Article = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Article"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-section-examples-padding': '0 10px 0 10px'
    }
  }
};
exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Specified node element will be passed as children of `<SectionHeadingRenderer />` component. */
  children: _propTypes.default.node,
  // eslint-disable-line react/require-default-props

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-section-examples-padding': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
exports.propTypes = propTypes;

var ExamplesRendererUnstyled = function ExamplesRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      cssModule = _omit.cssModule,
      children = _omit.children,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "cssModule", "children"]);

  return _react.default.createElement(_Article.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-examples'), cssModule)
  }, attributes), children);
};

ExamplesRendererUnstyled.defaultProps = defaultProps;
ExamplesRendererUnstyled.propTypes = propTypes;
var ExamplesRenderer = (0, _styledComponents.default)(ExamplesRendererUnstyled).withConfig({
  displayName: "ExamplesRenderer",
  componentId: "sc-8cc49m-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-examples {\n      padding: ".concat(props.theme.styleguide['$rsg-section-examples-padding'], ";\n    }\n ");
});
ExamplesRenderer.defaultProps = defaultProps;
ExamplesRenderer.propTypes = propTypes;
/** @component */

var _default = ExamplesRenderer;
exports.default = _default;