"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _A = _interopRequireDefault(require("@bootstrap-styled/v4/lib/A"));

var _hover = require("@bootstrap-styled/css-mixins/lib/hover");

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-link-hover-isolate': 'false'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-link-hover-isolate': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var LinkRendererUnstyled = function LinkRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "cssModule"]);

  return _react.default.createElement(_A.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-link'), cssModule)
  }, attributes));
};

LinkRendererUnstyled.defaultProps = defaultProps;
LinkRendererUnstyled.propTypes = propTypes;
var LinkRenderer = (0, _styledComponents.default)(LinkRendererUnstyled).withConfig({
  displayName: "LinkRenderer",
  componentId: "d2cmcb-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-link {\n  ".concat((0, _hover.hover)("\n      isolation: ".concat(props.theme.styleguide['$rsg-link-hover-isolate'], ";\n    ")), "\n      &:active {\n        isolation: ").concat(props.theme.styleguide['$rsg-link-hover-isolate'], ";\n      }\n    }\n ");
});
LinkRenderer.defaultProps = defaultProps;
LinkRenderer.propTypes = propTypes;
/** @component */

var _default = LinkRenderer;
exports.default = _default;