"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _H = _interopRequireDefault(require("@bootstrap-styled/v4/lib/H1"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-logo-color': '#fff',
      '$rsg-logo-margin': '0',
      '$rsg-logo-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif',
      '$rsg-logo-font-size': '18px',
      '$rsg-logo-font-weight': 'normal'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-logo-color': _propTypes.default.string,
      '$rsg-logo-margin': _propTypes.default.string,
      '$rsg-logo-font-family': _propTypes.default.string,
      '$rsg-logo-font-size': _propTypes.default.string,
      '$rsg-logo-font-weight': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var LogoRendererUnstyled = function LogoRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "cssModule"]);

  return _react.default.createElement(_H.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-logo'), cssModule)
  }, attributes));
};

LogoRendererUnstyled.defaultProps = defaultProps;
LogoRendererUnstyled.propTypes = propTypes;
var LogoRenderer = (0, _styledComponents.default)(LogoRendererUnstyled).withConfig({
  displayName: "LogoRenderer",
  componentId: "gfaced-0"
})(["", ""], function (props) {
  return "\n    &.rsg-logo {\n      color: ".concat(props.theme.styleguide['$rsg-logo-color'], ";\n      margin: ").concat(props.theme.styleguide['$rsg-logo-margin'], ";\n      font-family: ").concat(props.theme.styleguide['$rsg-logo-font-family'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-logo-font-size'], ";\n      font-weight: ").concat(props.theme.styleguide['$rsg-logo-font-weight'], ";\n    }\n ");
});
LogoRenderer.defaultProps = defaultProps;
LogoRenderer.propTypes = propTypes;
/** @component */

var _default = LogoRenderer;
exports.default = _default;