"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Details = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Details"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-markdown-details-margin-bottom': '0',
      '$rsg-markdown-details-font-family': '0',
      '$rsg-markdown-details-font-size': '0',
      '$rsg-markdown-details-color': '0'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Specified node element will be passed as children of `<HeadingRenderer />` component. */
  children: _propTypes.default.node.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-heading-margin': _propTypes.default.string,
      '$rsg-markdown-details-margin-bottom': _propTypes.default.string,
      '$rsg-markdown-details-font-family': _propTypes.default.string,
      '$rsg-markdown-details-font-size': _propTypes.default.string,
      '$rsg-markdown-details-color': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var DetailsRendererUnstyled = function DetailsRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "cssModule"]);

  return _react.default.createElement(_Details.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-markdown-details'), cssModule)
  }, attributes), children);
};

DetailsRendererUnstyled.defaultProps = defaultProps;
DetailsRendererUnstyled.propTypes = propTypes;
var DetailsRenderer = (0, _styledComponents.default)(DetailsRendererUnstyled).withConfig({
  displayName: "DetailsRenderer",
  componentId: "sc-1ua3x8v-0"
})(["", ";"], function (props) {
  return "\n      &.rsg-markdown-details {\n        margin-bottom: ".concat(props.theme.styleguide['$rsg-markdown-details-margin-bottom'], ";\n        font-family: ").concat(props.theme.styleguide['$rsg-markdown-details-font-family'], ";\n        font-size: ").concat(props.theme.styleguide['$rsg-markdown-details-font-size'], ";\n        color: ").concat(props.theme.styleguide['$rsg-markdown-detail-color'], ";\n    }\n  ");
});
var _default = DetailsRenderer;
exports.default = _default;