"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Summary = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Summary"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-markdown-details-summary-margin-bottom': '0',
      '$rsg-markdown-details-summary-font-family': '0',
      '$rsg-markdown-details-summary-font-size': '0',
      '$rsg-markdown-details-summary-color': '0',
      '$rsg-markdown-details-summary-focused-isolate': 'false',
      '$rsg-markdown-details-summary-focused-outline': ' 1 dotted blue',
      '$rsg-markdown-details-summary-focused-outline-offset': '2'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Specified node element will be passed as children of `<HeadingRenderer />` component. */
  children: _propTypes.default.node.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-heading-margin': _propTypes.default.string,
      '$rsg-markdown-details-summary-margin-bottom': _propTypes.default.string,
      '$rsg-markdown-details-summary-font-family': _propTypes.default.string,
      '$rsg-markdown-details-summary-font-size': _propTypes.default.string,
      '$rsg-markdown-details-summary-color': _propTypes.default.string,
      '$rsg-markdown-details-summary-focused-isolate': _propTypes.default.string,
      '$rsg-markdown-details-summary-focused-outline': _propTypes.default.string,
      '$rsg-markdown-details-summary-focused-outline-offset': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var DetailsSummaryRendererUnstyled = function DetailsSummaryRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "cssModule"]);

  return _react.default.createElement(_Summary.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-markdown-details-summary'), cssModule)
  }, attributes), children);
};

DetailsSummaryRendererUnstyled.defaultProps = defaultProps;
DetailsSummaryRendererUnstyled.propTypes = propTypes;
var DetailsSummaryRenderer = (0, _styledComponents.default)(DetailsSummaryRendererUnstyled).withConfig({
  displayName: "DetailsSummaryRenderer",
  componentId: "sc-17k91e5-0"
})(["", ";"], function (props) {
  return "\n      &.rsg-markdown-details-summary {\n        margin-bottom: ".concat(props.theme.styleguide['$rsg-markdown-details-margin-bottom'], ";\n        font-family: ").concat(props.theme.styleguide['$rsg-markdown-details-font-family'], ";\n        font-size: ").concat(props.theme.styleguide['$rsg-markdown-details-font-size'], ";\n        color: ").concat(props.theme.styleguide['$rsg-markdown-detail-color'], ";\n        &:focus {\n          isolate: ").concat(props.theme.styleguide['$rsg-markdown-details-summary-focused-isolate'], ";\n          outline: ").concat(props.theme.styleguide['$rsg-markdown-details-summary-focused-outline'], ";\n          outline-offset: ").concat(props.theme.styleguide['$rsg-markdown-details-summary-focused-outline-offset'], ";\n        }\n    }\n  ");
});
var _default = DetailsSummaryRenderer;
exports.default = _default;