"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Ol = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Ol"));

var _Ul = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Ul"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  ordered: false,
  theme: {
    styleguide: {
      '$rsg-markdown-list-margin': '0 0 16px 0',
      '$rsg-markdown-list-padding': '0 0 0 24px',
      '$rsg-markdown-list-font-size': 'inherit',
      '$rsg-markdown-list-ordered-style-type': 'decimal',
      '$rsg-markdown-list-li-color': '#333',
      '$rsg-markdown-list-li-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif',
      '$rsg-markdown-list-li-font-size': 'inherit',
      '$rsg-markdown-list-li-line-height': '1.5',
      '$rsg-markdown-list-li-style-type': 'inherit'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props
  children: _propTypes.default.node.isRequired,
  ordered: _propTypes.default.bool,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-markdown-list-margin': _propTypes.default.string,
      '$rsg-markdown-list-padding': _propTypes.default.string,
      '$rsg-markdown-list-font-size': _propTypes.default.string,
      '$rsg-markdown-list-ordered-style-type': _propTypes.default.string,
      '$rsg-markdown-list-li-color': _propTypes.default.string,
      '$rsg-markdown-list-li-font-family': _propTypes.default.string,
      '$rsg-markdown-list-li-font-size': _propTypes.default.string,
      '$rsg-markdown-list-li-line-height': _propTypes.default.string,
      '$rsg-markdown-list-li-style-type': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var ListRendererUnstyled = function ListRendererUnstyled(props) {
  // eslint-disable-next-line no-shadow
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      ordered = _omit.ordered,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "ordered", "cssModule"]);

  var Tag = ordered ? _Ol.default : _Ul.default;
  return _react.default.createElement(Tag, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-markdown-list', "list-".concat(ordered ? 'ol' : 'ul')), cssModule)
  }, attributes), _react.Children.map(children, function (Li) {
    return (0, _react.cloneElement)(Li);
  }));
};

ListRendererUnstyled.defaultProps = defaultProps;
ListRendererUnstyled.propTypes = propTypes;
var ListRenderer = (0, _styledComponents.default)(ListRendererUnstyled).withConfig({
  displayName: "ListRenderer",
  componentId: "sc-1me90o1-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-markdown-list {\n      font-size: ".concat(props.theme.styleguide['$rsg-markdown-list-font-size'], ";\n      margin: ").concat(props.theme.styleguide['$rsg-markdown-list-margin'], ";\n      padding: ").concat(props.theme.styleguide['$rsg-markdown-list-padding'], ";\n    }\n    &.rsg-markdown-list.list-ol {\n      list-style-type: ").concat(props.theme.styleguide['$rsg-markdown-list-ordered-style-type'], " ;\n    }\n    &.rsg-markdown-list.list-ul {\n      font-family: ").concat(props.theme.styleguide['$rsg-markdown-list-li-font-family'], " ;\n      font-size: ").concat(props.theme.styleguide['$rsg-markdown-list-li-font-size'], " !important;\n      color: ").concat(props.theme.styleguide['$rsg-markdown-list-li-color'], " !important;\n      line-height: ").concat(props.theme.styleguide['$rsg-markdown-list-li-line-height'], " ;\n      list-style-type: ").concat(props.theme.styleguide['$rsg-markdown-list-li-style-type'], " ;\n    }\n ");
});
ListRenderer.defaultProps = defaultProps;
ListRenderer.propTypes = propTypes;
var _default = ListRenderer;
exports.default = _default;