"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.inlineOverrides = exports.baseOverrides = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _markdownToJsx = require("markdown-to-jsx");

var _Table = require("./Table");

var _MarkdownHeading = _interopRequireDefault(require("./MarkdownHeading"));

var _List = _interopRequireDefault(require("./List"));

var _Blockquote = _interopRequireDefault(require("./Blockquote"));

var _Pre = _interopRequireDefault(require("./Pre"));

var _Code = _interopRequireDefault(require("../Code"));

var _Checkbox = _interopRequireDefault(require("./Checkbox"));

var _Hr = _interopRequireDefault(require("./Hr"));

var _DetailsRenderer = _interopRequireDefault(require("./Details/DetailsRenderer"));

var _DetailsSummaryRenderer = _interopRequireDefault(require("./Details/DetailsSummaryRenderer"));

var _Link = _interopRequireDefault(require("../Link"));

var _Text = _interopRequireDefault(require("../Text"));

var _Para = _interopRequireDefault(require("../Para"));

require("./tomorrow.css");

var baseOverrides = {
  a: {
    component: _Link.default
  },
  h1: {
    component: _MarkdownHeading.default,
    props: {
      level: 1
    }
  },
  h2: {
    component: _MarkdownHeading.default,
    props: {
      level: 2
    }
  },
  h3: {
    component: _MarkdownHeading.default,
    props: {
      level: 3
    }
  },
  h4: {
    component: _MarkdownHeading.default,
    props: {
      level: 4
    }
  },
  h5: {
    component: _MarkdownHeading.default,
    props: {
      level: 5
    }
  },
  h6: {
    component: _MarkdownHeading.default,
    props: {
      level: 6
    }
  },
  p: {
    component: _Para.default,
    props: {
      semantic: 'p'
    }
  },
  em: {
    component: _Text.default,
    props: {
      semantic: 'em'
    }
  },
  strong: {
    component: _Text.default,
    props: {
      semantic: 'strong'
    }
  },
  ul: {
    component: _List.default
  },
  ol: {
    component: _List.default,
    props: {
      ordered: true
    }
  },
  blockquote: {
    component: _Blockquote.default
  },
  code: {
    component: _Code.default
  },
  pre: {
    component: _Pre.default
  },
  input: {
    component: _Checkbox.default
  },
  hr: {
    component: _Hr.default
  },
  table: {
    component: _Table.Table
  },
  thead: {
    component: _Table.TableHead
  },
  th: {
    component: _Table.TableCell,
    props: {
      header: true
    }
  },
  tbody: {
    component: _Table.TableBody
  },
  tr: {
    component: _Table.TableRow
  },
  td: {
    component: _Table.TableCell
  },
  details: {
    component: _DetailsRenderer.default
  },
  summary: {
    component: _DetailsSummaryRenderer.default
  }
};
exports.baseOverrides = baseOverrides;
var inlineOverrides = (0, _objectSpread2.default)({}, baseOverrides, {
  p: {
    component: _Text.default
  }
});
exports.inlineOverrides = inlineOverrides;

function Markdown(_ref) {
  var text = _ref.text,
      inline = _ref.inline;
  var overrides = inline ? inlineOverrides : baseOverrides;
  return (0, _markdownToJsx.compiler)(text, {
    overrides: overrides,
    forceBlock: true
  });
}

Markdown.propTypes = {
  text: _propTypes.default.string.isRequired,
  inline: _propTypes.default.bool
};
var _default = Markdown;
exports.default = _default;