"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Pre = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Pre"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-markdown-pre-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif;',
      '$rsg-markdown-pre-font-size': '13px',
      '$rsg-markdown-pre-line-height': '1.5',
      '$rsg-markdown-pre-color': '#333',
      '$rsg-markdown-pre-white-space': 'pre',
      '$rsg-markdown-pre-background-color': '#f5f5f5',
      '$rsg-markdown-pre-padding': '8px 16px',
      '$rsg-markdown-pre-border': '1px #e8e8e8 solid',
      '$rsg-markdown-pre-border-radius': '3px',
      '$rsg-markdown-pre-margin': '0 0 16px 0'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props
  children: _propTypes.default.node.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-markdown-pre-font-family': _propTypes.default.string,
      '$rsg-markdown-pre-font-size': _propTypes.default.string,
      '$rsg-markdown-pre-line-height': _propTypes.default.string,
      '$rsg-markdown-pre-color': _propTypes.default.string,
      '$rsg-markdown-pre-white-space': _propTypes.default.string,
      '$rsg-markdown-pre-background-color': _propTypes.default.string,
      '$rsg-markdown-pre-padding': _propTypes.default.string,
      '$rsg-markdown-pre-border': _propTypes.default.string,
      '$rsg-markdown-pre-border-radius': _propTypes.default.string,
      '$rsg-markdown-pre-margin': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var PreRendererUnstyled = function PreRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "cssModule"]);

  return _react.default.createElement(_Pre.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-markdown-pre'), cssModule)
  }, attributes), children);
};

PreRendererUnstyled.defaultProps = defaultProps;
PreRendererUnstyled.propTypes = propTypes;
var PreRenderer = (0, _styledComponents.default)(PreRendererUnstyled).withConfig({
  displayName: "PreRenderer",
  componentId: "sc-1jda7gz-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-markdown-pre {\n      font-family: ".concat(props.theme.styleguide['$rsg-markdown-pre-font-family'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-markdown-pre-font-size'], ";\n      line-height: ").concat(props.theme.styleguide['$rsg-markdown-pre-line-height'], ";\n      color: ").concat(props.theme.styleguide['$rsg-markdown-pre-color'], " !important;\n      white-space: ").concat(props.theme.styleguide['$rsg-markdown-pre-white-space'], ";\n      background-color: ").concat(props.theme.styleguide['$rsg-markdown-pre-background-color'], ";\n      padding: ").concat(props.theme.styleguide['$rsg-markdown-pre-padding'], ";\n      border: ").concat(props.theme.styleguide['$rsg-markdown-pre-border'], ";\n      border-radius: ").concat(props.theme.styleguide['$rsg-markdown-pre-border-radius'], ";\n      margin: ").concat(props.theme.styleguide['$rsg-markdown-pre-margin'], ";\n    }\n ");
});
PreRenderer.defaultProps = defaultProps;
PreRenderer.propTypes = propTypes;
var _default = PreRenderer;
exports.default = _default;