"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Th = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Th"));

var _Td = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Td"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-markdown-table-cell-padding': '4px 16px 4px 0',
      '$rsg-markdown-table-cell-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif',
      '$rsg-markdown-table-cell-font-size': '15px',
      '$rsg-markdown-table-cell-color': '#292b2c',
      '$rsg-markdown-table-cell-line-height': '1.5',
      '$rsg-markdown-table-cell-head-font-weight': 'bold'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props
  children: _propTypes.default.node.isRequired,
  header: _propTypes.default.bool,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-markdown-table-cell-padding': _propTypes.default.string,
      '$rsg-markdown-table-cell-font-family': _propTypes.default.string,
      '$rsg-markdown-table-cell-font-size': _propTypes.default.string,
      '$rsg-markdown-table-cell-color': _propTypes.default.string,
      '$rsg-markdown-table-cell-line-height': _propTypes.default.string,
      '$rsg-markdown-table-cell-head-font-weight': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var TableCellRendererUnstyled = function TableCellRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      header = _omit.header,
      children = _omit.children,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "header", "children", "cssModule"]);

  if (header) {
    return _react.default.createElement(_Th.default, (0, _extends2.default)({
      className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-markdown-table-cell-head'), cssModule)
    }, attributes), children);
  }

  return _react.default.createElement(_Td.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-markdown-table-cell'), cssModule)
  }, attributes), children);
};

TableCellRendererUnstyled.defaultProps = defaultProps;
TableCellRendererUnstyled.propTypes = propTypes;
var TableCellRenderer = (0, _styledComponents.default)(TableCellRendererUnstyled).withConfig({
  displayName: "TableCellRenderer",
  componentId: "sc-170j8fg-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-markdown-table-cell {\n      padding: ".concat(props.theme.styleguide['$rsg-markdown-table-cell-padding'], ";\n      font-family: ").concat(props.theme.styleguide['$rsg-markdown-table-cell-font-family'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-markdown-table-cell-font-size'], ";\n      color: ").concat(props.theme.styleguide['$rsg-markdown-table-cell-color'], ";\n      line-height: ").concat(props.theme.styleguide['$rsg-markdown-table-cell-line-height'], ";\n    }\n    &.rsg-markdown-table-cell-head {\n      font-weight: ").concat(props.theme.styleguide['$rsg-markdown-table-cell-head-font-weight'], ";\n    }\n ");
});
TableCellRenderer.defaultProps = defaultProps;
TableCellRenderer.propTypes = propTypes;
var _default = TableCellRenderer;
exports.default = _default;