"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Table = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-markdown-table-margin': '0 0 8px 0',
      '$rsg-markdown-border-collapse': 'collapse'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props
  children: _propTypes.default.node.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-markdown-table-margin': _propTypes.default.string,
      '$rsg-markdown-border-collapse': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var TableRendererUnstyled = function TableRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "cssModule"]);

  return _react.default.createElement(_Table.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-markdown-table'), cssModule)
  }, attributes), children);
};

TableRendererUnstyled.defaultProps = defaultProps;
TableRendererUnstyled.propTypes = propTypes;
var TableRenderer = (0, _styledComponents.default)(TableRendererUnstyled).withConfig({
  displayName: "TableRenderer",
  componentId: "sc-1u7bv9g-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-markdown-table {\n      margin: ".concat(props.theme.styleguide['$rsg-markdown-table-margin'], ";\n      border-collapse: ").concat(props.theme.styleguide['$rsg-markdown-table-border-collapse'], ";\n    }\n ");
});
TableRenderer.defaultProps = defaultProps;
TableRenderer.propTypes = propTypes;
var _default = TableRenderer;
exports.default = _default;