"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Markdown = _interopRequireDefault(require("../Markdown"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-message-margin': '0 0 32px 0'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Specified node element will be passed as children of `<MessageRenderer />` component. */
  children: _propTypes.default.node.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-message-margin': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var MessageRendererUnstyled = function MessageRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "cssModule"]);

  return _react.default.createElement("div", (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-message'), cssModule)
  }, attributes), _react.default.createElement(_Markdown.default, {
    text: Array.isArray(children) ? children.join('\n') : children
  }));
};

MessageRendererUnstyled.defaultProps = defaultProps;
MessageRendererUnstyled.propTypes = propTypes;
var MessageRenderer = (0, _styledComponents.default)(MessageRendererUnstyled).withConfig({
  displayName: "MessageRenderer",
  componentId: "ewsodj-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-message {\n      margin: ".concat(props.theme.styleguide['$rsg-message-margin'], ";\n    }\n ");
});
MessageRenderer.defaultProps = defaultProps;
MessageRenderer.propTypes = propTypes;
/** @component */

var _default = MessageRenderer;
exports.default = _default;