"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = MethodsRenderer;
exports.columns = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Markdown = _interopRequireDefault(require("../Markdown"));

var _Argument = _interopRequireDefault(require("../Argument"));

var _Arguments = _interopRequireDefault(require("../Arguments"));

var _Name = _interopRequireDefault(require("../Name"));

var _JsDoc = _interopRequireDefault(require("../JsDoc"));

var _Table = _interopRequireDefault(require("../Table"));

var getRowKey = function getRowKey(row) {
  return row.name;
};

var columns = [{
  caption: 'Method name',
  // eslint-disable-next-line react/prop-types
  render: function render(_ref) {
    var name = _ref.name,
        _ref$tags = _ref.tags,
        tags = _ref$tags === void 0 ? {} : _ref$tags;
    return _react.default.createElement(_Name.default, {
      deprecated: !!tags.deprecated
    }, "".concat(name, "()"));
  }
}, {
  caption: 'Parameters',
  // eslint-disable-next-line react/prop-types
  render: function render(_ref2) {
    var _ref2$params = _ref2.params,
        params = _ref2$params === void 0 ? [] : _ref2$params;
    return _react.default.createElement(_Arguments.default, {
      args: params
    });
  }
}, {
  caption: 'Description',
  // eslint-disable-next-line react/prop-types
  render: function render(_ref3) {
    var description = _ref3.description,
        returns = _ref3.returns,
        _ref3$tags = _ref3.tags,
        tags = _ref3$tags === void 0 ? {} : _ref3$tags;
    return _react.default.createElement("div", null, description && _react.default.createElement(_Markdown.default, {
      text: description
    }), returns && _react.default.createElement(_Argument.default, (0, _extends2.default)({
      block: true,
      returns: true
    }, returns)), _react.default.createElement(_JsDoc.default, tags));
  }
}];
exports.columns = columns;

function MethodsRenderer(_ref4) {
  var methods = _ref4.methods;
  return _react.default.createElement(_Table.default, {
    columns: columns,
    rows: methods,
    getRowKey: getRowKey
  });
}

MethodsRenderer.propTypes = {
  /** Methods (props) information. Can be: */
  methods: _propTypes.default.arrayOf(_propTypes.default.shape({
    name: _propTypes.default.string.isRequired,
    description: _propTypes.default.string,
    returns: _propTypes.default.object,
    params: _propTypes.default.array,
    tags: _propTypes.default.object
  })).isRequired
};