"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Code = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Code"));

var _breakpoints = _interopRequireDefault(require("@bootstrap-styled/css-mixins/lib/breakpoints"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-name-word-wrap': 'break-word',
      '$rsg-name-font-size': {
        xs: '12px',
        sm: '15px'
      },
      '$rsg-name-color': '#b11255',
      '$rsg-name-deprecated-color': '#f47469',
      '$rsg-name-deprecated-decoration': 'line-through'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Specified node element will be passed as children of `<NameRenderer />` component. */
  children: _propTypes.default.node.isRequired,

  /** Toggle deprecated style. */
  deprecated: _propTypes.default.bool,
  // eslint-disable-line react/require-default-props

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-name-word-wrap': _propTypes.default.string,
      '$rsg-name-font-size': _propTypes.default.shape({
        xs: _propTypes.default.string,
        sm: _propTypes.default.string
      }),
      '$rsg-name-color': _propTypes.default.string,
      '$rsg-name-deprecated-color': _propTypes.default.string,
      '$rsg-name-deprecated-decoration': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var NameRendererUnstyled = function NameRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      deprecated = _omit.deprecated,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "deprecated", "cssModule"]);

  return _react.default.createElement("span", (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-name'), cssModule)
  }, attributes), _react.default.createElement(_Code.default, {
    className: "name-renderer-code ".concat(deprecated ? 'deprecated' : '')
  }, children));
};

NameRendererUnstyled.defaultProps = defaultProps;
NameRendererUnstyled.propTypes = propTypes;
var NameRenderer = (0, _styledComponents.default)(NameRendererUnstyled).withConfig({
  displayName: "NameRenderer",
  componentId: "flidvs-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-name {\n      .name-renderer-code {\n        word-wrap: ".concat(props.theme.styleguide['$rsg-name-word-wrap'], ";\n  ").concat(_breakpoints.default.up('xs', props.theme['$grid-breakpoints'], "\n      font-size: ".concat(props.theme.styleguide['$rsg-name-font-size'].xs, ";\n    ")), "\n  ").concat(_breakpoints.default.up('sm', props.theme['$grid-breakpoints'], "\n     font-size: ".concat(props.theme.styleguide['$rsg-name-font-size'].sm, ";\n    ")), "\n        color: ").concat(props.theme.styleguide['$rsg-name-color'], ";\n      }\n      .name-renderer-code.deprecated {\n        color: ").concat(props.theme.styleguide['$rsg-name-deprecated-color'], ";\n        text-decoration: ").concat(props.theme.styleguide['$rsg-name-deprecated-decoration'], ";\n      }\n    }\n ");
});
NameRenderer.defaultProps = defaultProps;
NameRenderer.propTypes = propTypes;
/** @component */

var _default = NameRenderer;
exports.default = _default;