"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Markdown = _interopRequireDefault(require("../Markdown"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-not-found-max-width': '0',
      '$rsg-not-found-margin': '0 auto'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-not-found-max-width': _propTypes.default.string,
      '$rsg-not-found-margin': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var NotFoundRendererUnstyled = function NotFoundRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "cssModule"]);

  return _react.default.createElement("div", (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-markdown-details'), cssModule)
  }, attributes), _react.default.createElement(_Markdown.default, {
    text: "# Page not found. The link you followed may be broken, or the page may have been removed."
  }));
};

NotFoundRendererUnstyled.defaultProps = defaultProps;
NotFoundRendererUnstyled.propTypes = propTypes;
var NotFoundRenderer = (0, _styledComponents.default)(NotFoundRendererUnstyled).withConfig({
  displayName: "NotFoundRenderer",
  componentId: "sc-155qzk9-0"
})(["", ";"], function (props) {
  return "\n      &.rsg-not-found {\n        max-width: ".concat(props.theme.styleguide['$rsg-not-found-max-width'], ";\n        margin: ").concat(props.theme.styleguide['$rsg-not-found-margin'], ";\n    }\n  ");
});
/** @component */

var _default = NotFoundRenderer;
exports.default = _default;