"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _P = _interopRequireDefault(require("@bootstrap-styled/v4/lib/P"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-para-margin': '0 0 8px 0',
      '$rsg-para-color': '#333',
      '$rsg-para-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif',
      '$rsg-para-font-size': 'inherit',
      '$rsg-para-line-height': '1.5'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Specified node element will be passed as children of `<ParaRenderer />` component. */
  children: _propTypes.default.node.isRequired,

  /** Tag used for semantic. */
  semantic: _propTypes.default.oneOf(['p']),

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-para-margin': _propTypes.default.string,
      '$rsg-para-color': _propTypes.default.string,
      '$rsg-para-font-family': _propTypes.default.string,
      '$rsg-para-font-size': _propTypes.default.string,
      '$rsg-para-line-height': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var ParaRendererUnstyled = function ParaRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      semantic = _omit.semantic,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "semantic", "cssModule"]);

  var Tag = semantic && _P.default || 'div';
  return _react.default.createElement(Tag, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-para'), cssModule)
  }, attributes), children);
};

ParaRendererUnstyled.defaultProps = defaultProps;
ParaRendererUnstyled.propTypes = propTypes;
var ParaRenderer = (0, _styledComponents.default)(ParaRendererUnstyled).withConfig({
  displayName: "ParaRenderer",
  componentId: "dkuw0l-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-para {\n      margin: ".concat(props.theme.styleguide['$rsg-para-margin'], ";\n      color: ").concat(props.theme.styleguide['$rsg-para-color'], ";\n      font-family: ").concat(props.theme.styleguide['$rsg-para-font-family'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-para-font-size'], ";\n      line-height: ").concat(props.theme.styleguide['$rsg-para-line-height'], ";\n    }\n ");
});
/** @component */

var _default = ParaRenderer;
exports.default = _default;