"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-playground-margin': '0',
      '$rsg-playground-preview-padding': '16px',
      '$rsg-playground-preview-border': '1px #e8e8e8 solid',
      '$rsg-playground-preview-border-radius': '3px',
      '$rsg-playground-preview-width': '100%',
      '$rsg-playground-preview-display': 'inline-block',
      '$rsg-playground-controls-display': 'flex',
      '$rsg-playground-controls-align-items': 'center',
      '$rsg-playground-toolbar-margin': '0 0 0 auto'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Name used in data-preview. */
  name: _propTypes.default.string.isRequired,

  /** Preview element to be rendered. */
  preview: _propTypes.default.node.isRequired,

  /** Preview properties to be rendered. */
  previewProps: _propTypes.default.object.isRequired,

  /** Tab button to be rendered. */
  tabButtons: _propTypes.default.node.isRequired,

  /** Tab body to be rendered. */
  tabBody: _propTypes.default.node.isRequired,

  /** Toolbar to be rendered. */
  toolbar: _propTypes.default.node.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-playground-margin': _propTypes.default.string,
      '$rsg-playground-preview-padding': _propTypes.default.string,
      '$rsg-playground-preview-border': _propTypes.default.string,
      '$rsg-playground-preview-border-radius': _propTypes.default.string,
      '$rsg-playground-preview-width': _propTypes.default.string,
      '$rsg-playground-preview-display': _propTypes.default.string,
      '$rsg-playground-controls-display': _propTypes.default.string,
      '$rsg-playground-controls-align-items': _propTypes.default.string,
      '$rsg-playground-toolbar-margin': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var PlaygroundRendererUnstyled = function PlaygroundRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      name = _omit.name,
      preview = _omit.preview,
      previewProps = _omit.previewProps,
      tabButtons = _omit.tabButtons,
      tabBody = _omit.tabBody,
      toolbar = _omit.toolbar,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "name", "preview", "previewProps", "tabButtons", "tabBody", "toolbar", "cssModule"]);

  return _react.default.createElement("div", (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-playground'), cssModule)
  }, attributes), _react.default.createElement("div", (0, _extends2.default)({
    className: "rsg-playground-preview",
    "data-preview": name
  }, previewProps), preview), _react.default.createElement("div", {
    className: "rsg-playground-control d-flex justify-content-between"
  }, _react.default.createElement("div", null, tabButtons), _react.default.createElement("div", {
    className: "rsg-playground-toolbar"
  }, toolbar)), _react.default.createElement("div", null, tabBody));
};

PlaygroundRendererUnstyled.defaultProps = defaultProps;
PlaygroundRendererUnstyled.propTypes = propTypes;
var PlaygroundRenderer = (0, _styledComponents.default)(PlaygroundRendererUnstyled).withConfig({
  displayName: "PlaygroundRenderer",
  componentId: "m01qpj-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-playground {\n      margin: ".concat(props.theme.styleguide['$rsg-playground-margin'], ";\n      .rsg-playground-preview {\n        padding: ").concat(props.theme.styleguide['$rsg-playground-preview-padding'], ";\n        border: ").concat(props.theme.styleguide['$rsg-playground-preview-border'], ";\n        border-radius: ").concat(props.theme.styleguide['$rsg-playground-preview-border-radius'], ";\n        width: ").concat(props.theme.styleguide['$rsg-playground-preview-width'], ";\n        display: ").concat(props.theme.styleguide['$rsg-playground-preview-display'], ";\n      }\n      .rsg-playground-control {\n        display: ").concat(props.theme.styleguide['$rsg-playground-controls-display'], ";\n        align-items: ").concat(props.theme.styleguide['$rsg-playground-controls-align-items'], ";\n        .rsg-playground-toolbar {\n          margin: ").concat(props.theme.styleguide['$rsg-playground-toolbar-margin'], ";\n        }\n      }\n    }\n ");
});
PlaygroundRenderer.defaultProps = defaultProps;
PlaygroundRenderer.propTypes = propTypes;
/** @component */

var _default = PlaygroundRenderer;
exports.default = _default;