"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Pre = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Pre"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-playground-error-margin': '0',
      '$rsg-playground-error-line-height': '1.2',
      '$rsg-playground-error-font-size': '13px',
      '$rsg-playground-error-font-family': 'Consolas, "Liberation Mono", Menlo, monospace',
      '$rsg-playground-error-color': '#c00',
      '$rsg-playground-error-white-space': 'pre-wrap'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** String passed as children to `<PlaygroundErrorRenderer />`. */
  message: _propTypes.default.string.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-playground-error-margin': _propTypes.default.string,
      '$rsg-playground-error-line-height': _propTypes.default.string,
      '$rsg-playground-error-font-size': _propTypes.default.string,
      '$rsg-playground-error-font-family': _propTypes.default.string,
      '$rsg-playground-error-color': _propTypes.default.string,
      '$rsg-playground-error-white-space': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var PlaygroundErrorRendererUnstyled = function PlaygroundErrorRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      message = _omit.message,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "message", "cssModule"]);

  return _react.default.createElement(_Pre.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-playground-error'), cssModule)
  }, attributes), message);
};

PlaygroundErrorRendererUnstyled.defaultProps = defaultProps;
PlaygroundErrorRendererUnstyled.propTypes = propTypes;
var PlaygroundErrorRenderer = (0, _styledComponents.default)(PlaygroundErrorRendererUnstyled).withConfig({
  displayName: "PlaygroundErrorRenderer",
  componentId: "sc-42tpeo-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-playground-error {\n      margin: ".concat(props.theme.styleguide['$rsg-playground-error-margin'], ";\n      line-height: ").concat(props.theme.styleguide['$rsg-playground-error-line-height'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-playground-error-font-size'], ";\n      font-family; ").concat(props.theme.styleguide['$rsg-playground-error-font-family'], ";\n      color: ").concat(props.theme.styleguide['$rsg-playground-error-color'], ";\n      white-space: ").concat(props.theme.styleguide['$rsg-playground-error-white-space'], ";\n    }\n ");
});
PlaygroundErrorRenderer.defaultProps = defaultProps;
PlaygroundErrorRenderer.propTypes = propTypes;
/** @component */

var _default = PlaygroundErrorRenderer;
exports.default = _default;