"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Header = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Header"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Pathline = _interopRequireDefault(require("../Pathline"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-react-component-margin-bottom': '40px',
      '$rsg-react-component-header-margin-bottom': '16px',
      '$rsg-react-component-docs-color': '#333',
      '$rsg-react-component-docs-font-size': '16px',
      '$rsg-react-component-tabs-margin-bottom': '16px',
      '$rsg-react-component-tabs-button-margin-bottom': '8px',
      '$rsg-react-component-tabs-overflow-x': 'auto',
      '$rsg-react-component-tabs-max-width': '100%',
      '$rsg-react-component-tabs-webkit-overflow-scrolling': 'touch'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Name used in id. */
  visibleName: _propTypes.default.string,

  /** Heading element to be rendered. */
  heading: _propTypes.default.node.isRequired,

  /** Component directory file path. */
  filepath: _propTypes.default.string,

  /** Component directory path line. */
  pathLine: _propTypes.default.string,

  /** Tab buttons elements to be rendered. */
  tabButtons: _propTypes.default.node,

  /** Tab body element to be rendered. */
  tabBody: _propTypes.default.node,

  /** Description element to be rendered. */
  description: _propTypes.default.node,

  /** Documentation element to be rendered. */
  docs: _propTypes.default.node,

  /** Examples elements to be rendered. */
  examples: _propTypes.default.node,

  /** Toggle isolated style. */
  isolated: _propTypes.default.bool,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-react-component-margin-bottom': _propTypes.default.string,
      '$rsg-react-component-header-margin-bottom': _propTypes.default.string,
      '$rsg-react-component-docs-color': _propTypes.default.string,
      '$rsg-react-component-docs-font-size': _propTypes.default.string,
      '$rsg-react-component-tabs-margin-bottom': _propTypes.default.string,
      '$rsg-react-component-tabs-button-margin-bottom': _propTypes.default.string,
      '$rsg-react-component-tabs-overflow-x': _propTypes.default.string,
      '$rsg-react-component-tabs-max-width': _propTypes.default.string,
      '$rsg-react-component-tabs-webkit-overflow-scrolling': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var ReactComponentRendererUnstyled = function ReactComponentRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      visibleName = _omit.visibleName,
      heading = _omit.heading,
      pathLine = _omit.pathLine,
      description = _omit.description,
      docs = _omit.docs,
      examples = _omit.examples,
      tabButtons = _omit.tabButtons,
      tabBody = _omit.tabBody,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "visibleName", "heading", "pathLine", "description", "docs", "examples", "tabButtons", "tabBody", "cssModule"]);

  return _react.default.createElement("div", (0, _extends2.default)({
    id: "".concat(visibleName, "-container"),
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-react-component'), cssModule)
  }, attributes), _react.default.createElement(_Header.default, {
    className: "rsg-react-component-header"
  }, heading, pathLine && _react.default.createElement(_Pathline.default, null, pathLine)), (description || docs) && _react.default.createElement("div", {
    className: "rsg-react-component-docs"
  }, description, docs), tabButtons && _react.default.createElement("div", {
    className: "rsg-react-component-tabs"
  }, _react.default.createElement("div", {
    className: "rsg-react-component-tabs-button"
  }, tabButtons), _react.default.createElement("div", {
    className: "rsg-react-component-tabs-body"
  }, tabBody)), examples);
};

ReactComponentRendererUnstyled.defaultProps = defaultProps;
ReactComponentRendererUnstyled.propTypes = propTypes;
var ReactComponentRenderer = (0, _styledComponents.default)(ReactComponentRendererUnstyled).withConfig({
  displayName: "ReactComponentRenderer",
  componentId: "sc-1rudjeg-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-react-component {\n      margin-bottom: ".concat(props.theme.styleguide['$rsg-react-component-margin-bottom'], ";\n      .rsg-react-component-header {\n        margin-bottom: ").concat(props.theme.styleguide['$rsg-react-component-header-margin-bottom'], ";\n      }\n      .rsg-react-component-docs {\n        color: ").concat(props.theme.styleguide['$rsg-react-component-docs-color'], ";\n        font-size: ").concat(props.theme.styleguide['$rsg-react-component-docs-font-size'], ";\n      }\n      .rsg-react-component-tabs {\n        margin-bottom: ").concat(props.theme.styleguide['$rsg-react-component-tabs-margin-bottom'], ";\n        .rsg-react-component-tab-buttons {\n          margin-bottom: ").concat(props.theme.styleguide['$rsg-react-component-tabs-button-margin-bottom'], ";\n        }\n        .rsg-react-components-tabs-body {\n          overflow-x: ").concat(props.theme.styleguide['$rsg-react-component-tabs-overflow-x'], ";\n          max-width: ").concat(props.theme.styleguide['$rsg-react-component-tabs-max-width'], ";\n          -webkit-overflow-scrolling: ").concat(props.theme.styleguide['$rsg-react-component-tabs-webkit-overflow-scrolling'], ";\n        }\n      }\n    }\n ");
});
ReactComponentRenderer.defaultProps = defaultProps;
ReactComponentRenderer.propTypes = propTypes;
/** @component */

var _default = ReactComponentRenderer;
exports.default = _default;