"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _ReactComponentRenderer = _interopRequireDefault(require("../ReactComponentRenderer"));

/* eslint-disable */

/**
 * Testing our ReactComponentRenderer component
 */
var renderComponent = function renderComponent() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return (0, _enzyme.mount)(_react.default.createElement(_ReactComponentRenderer.default, props));
};

describe('<ReactComponentRenderer />', function () {
  var visibleName;
  var heading;
  beforeAll(function () {
    visibleName = 'heading';
    heading = _react.default.createElement("h1", null, "Heading");
  });
  it('should render an ComponentListRenderer with h1 tag', function () {
    var renderedComponent = renderComponent({
      visibleName: visibleName,
      heading: heading
    });
    expect(renderedComponent.find('h1').length).toEqual(1);
  });
  it('should render an ComponentListRenderer with div containing id equal to heading-container', function () {
    var renderedComponent = renderComponent({
      visibleName: visibleName,
      heading: heading
    });
    expect(renderedComponent.find('div').props().id).toEqual('heading-container');
  });
});