"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _A = _interopRequireDefault(require("@bootstrap-styled/v4/lib/A"));

var _breakpoints = _interopRequireDefault(require("@bootstrap-styled/css-mixins/lib/breakpoints"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-ribbon-bp-visibility': {
        xs: 'hidden',
        md: 'visible'
      },
      '$rsg-ribbon-position': 'fixed',
      '$rsg-ribbon-top': '0',
      '$rsg-ribbon-right': '0',
      '$rsg-ribbon-width': '149px',
      '$rsg-ribbon-height': '149px',
      '$rsg-ribbon-z-index': '999',
      '$rsg-ribbon-link-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", Cantarell, "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif',
      '$rsg-ribbon-link-position': 'relative',
      '$rsg-ribbon-link-right': '-37px',
      '$rsg-ribbon-link-top': '-22px',
      '$rsg-ribbon-link-display': 'block',
      '$rsg-ribbon-link-width': '190px',
      '$rsg-ribbon-link-padding': '4px 8px',
      '$rsg-ribbon-link-text-align': 'center',
      '$rsg-ribbon-link-color': '#fff',
      '$rsg-ribbon-link-font-size': '15px',
      '$rsg-ribbon-link-background': 'linear-gradient( to right, #B31255, #3A007D)',
      '$rsg-ribbon-link-decoration': 'none',
      '$rsg-ribbon-link-shadow': '0 -1px 0 rgba(0,0,0,.15)',
      '$rsg-ribbon-link-transform-origin': '0 0',
      '$rsg-ribbon-link-transform': 'rotate(45deg)',
      '$rsg-ribbon-link-cursor': 'pointer'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Set link url. */
  url: _propTypes.default.string.isRequired,

  /** Set message passed as child of `<A />` link component. */
  text: _propTypes.default.string.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-ribbon-bp-visibility': _propTypes.default.object,
      '$rsg-ribbon-position': _propTypes.default.string,
      '$rsg-ribbon-top': _propTypes.default.string,
      '$rsg-ribbon-right': _propTypes.default.string,
      '$rsg-ribbon-width': _propTypes.default.string,
      '$rsg-ribbon-height': _propTypes.default.string,
      '$rsg-ribbon-z-index': _propTypes.default.string,
      '$rsg-ribbon-link-font-family': _propTypes.default.string,
      '$rsg-ribbon-link-position': _propTypes.default.string,
      '$rsg-ribbon-link-right': _propTypes.default.string,
      '$rsg-ribbon-link-top': _propTypes.default.string,
      '$rsg-ribbon-link-display': _propTypes.default.string,
      '$rsg-ribbon-link-width': _propTypes.default.string,
      '$rsg-ribbon-link-padding': _propTypes.default.string,
      '$rsg-ribbon-link-text-align': _propTypes.default.string,
      '$rsg-ribbon-link-color': _propTypes.default.string,
      '$rsg-ribbon-link-font-size': _propTypes.default.string,
      '$rsg-ribbon-link-background': _propTypes.default.string,
      '$rsg-ribbon-link-decoration': _propTypes.default.string,
      '$rsg-ribbon-link-shadow': _propTypes.default.string,
      '$rsg-ribbon-link-transform-origin': _propTypes.default.string,
      '$rsg-ribbon-link-transform': _propTypes.default.string,
      '$rsg-ribbon-link-cursor': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var RibbonRendererUnstyled = function RibbonRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      url = _omit.url,
      text = _omit.text,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "url", "text", "cssModule"]);

  return _react.default.createElement("div", (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-ribbon'), cssModule)
  }, attributes), _react.default.createElement(_A.default, {
    className: "rsg-ribbon-link",
    href: url
  }, text));
};

RibbonRendererUnstyled.defaultProps = defaultProps;
RibbonRendererUnstyled.propTypes = propTypes;
var RibbonRenderer = (0, _styledComponents.default)(RibbonRendererUnstyled).withConfig({
  displayName: "RibbonRenderer",
  componentId: "sc-6ku9kf-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-ribbon {\n  ".concat(_breakpoints.default.up('xs', props.theme['$grid-breakpoints'], "\n      visibility: ".concat(props.theme.styleguide['$rsg-ribbon-bp-visibility'].xs, ";\n    ")), "\n  ").concat(_breakpoints.default.up('md', props.theme['$grid-breakpoints'], "\n      visibility: ".concat(props.theme.styleguide['$rsg-ribbon-bp-visibility'].md, ";\n    ")), "\n      position: ").concat(props.theme.styleguide['$rsg-ribbon-position'], ";\n      top: ").concat(props.theme.styleguide['$rsg-ribbon-top'], ";\n      right: ").concat(props.theme.styleguide['$rsg-ribbon-right'], ";\n      width: ").concat(props.theme.styleguide['$rsg-ribbon-width'], ";\n      height: ").concat(props.theme.styleguide['$rsg-ribbon-height'], ";\n      z-index: ").concat(props.theme.styleguide['$rsg-ribbon-z-index'], ";\n      .rsg-ribbon-link {\n        font-family: ").concat(props.theme.styleguide['$rsg-ribbon-link-font-family'], ";\n        position: ").concat(props.theme.styleguide['$rsg-ribbon-link-position'], ";\n        right: ").concat(props.theme.styleguide['$rsg-ribbon-link-right'], ";\n        top: ").concat(props.theme.styleguide['$rsg-ribbon-link-top'], ";\n        display: ").concat(props.theme.styleguide['$rsg-ribbon-link-display'], ";\n        width: ").concat(props.theme.styleguide['$rsg-ribbon-link-width'], ";\n        padding: ").concat(props.theme.styleguide['$rsg-ribbon-link-padding'], ";\n        text-align: ").concat(props.theme.styleguide['$rsg-ribbon-link-text-align'], ";\n        color: ").concat(props.theme.styleguide['$rsg-ribbon-link-color'], ";\n        font-size: ").concat(props.theme.styleguide['$rsg-ribbon-link-font-size'], ";\n        background: ").concat(props.theme.styleguide['$rsg-ribbon-link-background'], ";\n        text-decoration: ").concat(props.theme.styleguide['$rsg-ribbon-link-decoration'], ";\n        text-shadow: ").concat(props.theme.styleguide['$rsg-ribbon-link-shadow'], ";\n        transform-origin: ").concat(props.theme.styleguide['$rsg-ribbon-link-transform-origin'], ";\n        transform: ").concat(props.theme.styleguide['$rsg-ribbon-link-transform'], ";\n        cursor: ").concat(props.theme.styleguide['$rsg-ribbon-link-cursor'], ";\n      }\n    }\n ");
});
RibbonRenderer.defaultProps = defaultProps;
RibbonRenderer.propTypes = propTypes;
/** @component */

var _default = RibbonRenderer;
exports.default = _default;