"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _RibbonRenderer = _interopRequireDefault(require("../RibbonRenderer"));

/* eslint-disable */

/**
 * Testing our RibbonRenderer component
 */
var renderComponent = function renderComponent() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return (0, _enzyme.mount)(_react.default.createElement(_RibbonRenderer.default, props));
};

describe('<RibbonRenderer />', function () {
  var url;
  var text;
  beforeAll(function () {
    url = 'https://www.yeutech.com';
    text = 'Fork us';
  });
  it('should render an RibbonRenderer ', function () {
    var renderedComponent = renderComponent({
      url: url,
      text: text
    });
    expect(renderedComponent.length).toBe(1);
    expect(renderedComponent.find('a').props().href).toEqual('https://www.yeutech.com');
    expect(renderedComponent.find('a').props().children).toEqual('Fork us');
  });
});