"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _boxShadow = require("@bootstrap-styled/css-mixins/lib/box-shadow");

var _breakpoints = _interopRequireDefault(require("@bootstrap-styled/css-mixins/lib/breakpoints"));

var _NavigationStyleguide = _interopRequireDefault(require("@bootstrap-styled/navigation-bar/lib/NavigationStyleguide/NavigationStyleguide"));

var _Img = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Img"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Logo = _interopRequireDefault(require("../Logo"));

var _Version = _interopRequireDefault(require("../Version"));

var defaultProps = {
  logo: {
    logo: null,
    href: 'https://bootstrap-styled.github.io/rsg-components',
    target: null,
    alt: '@bootstrap-styled/rsg-components'
  },
  theme: {
    styleguide: {
      '$rsg-sidebar-box-shadow': {
        xs: 'none',
        md: 'none'
      },
      '$rsg-sidebar-linear-gradient': 'linear-gradient(#3A007D, #B31255)',
      '$rsg-sidebar-logo-padding': '30px 20px 0 20px',
      '$rsg-sidebar-logo-align': 'center',
      '$rsg-sidebar-title-line-height': '1',
      '$rsg-sidebar-title-word-wrap': 'break-word',
      '$rsg-sidebar-logo-svg-height': '35px',
      '$rsg-sidebar-logo-svg-margin': '0 0 0 -8px'
    }
  },
  shadow: true,
  version: null
};
exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** enable or disable the shadow */
  shadow: _propTypes.default.bool,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-sidebar-box-shadow': _propTypes.default.object,
      '$rsg-sidebar-linear-gradient': _propTypes.default.string,
      '$rsg-sidebar-logo-padding': _propTypes.default.string,
      '$rsg-sidebar-logo-align': _propTypes.default.string,
      '$rsg-sidebar-title-line-height': _propTypes.default.string,
      '$rsg-sidebar-title-word-wrap': _propTypes.default.string,
      '$rsg-sidebar-logo-svg-height': _propTypes.default.string,
      '$rsg-sidebar-logo-svg-margin': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-import styled from 'styled-components';
  to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object,
  // eslint-disable-line react/require-default-props

  /** Logo attributes in order to render logo. */
  logo: _propTypes.default.shape({
    /** a webpack import or the <img /> directly */
    logo: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),

    /** the logo link href */
    href: _propTypes.default.string,

    /** the logo link target */
    target: _propTypes.default.string,

    /** the logo link alt */
    alt: _propTypes.default.string
  }),

  /** the package version */
  version: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Set title to be rendered. */
  title: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Table of content elements to be rendered. */
  items: _propTypes.default.node // eslint-disable-line react/require-default-props

};
/**
 * The SideBar component have many props that can be customized
 * @param props
 * @returns {*}
 * @constructor
 */

exports.propTypes = propTypes;

var SideBarUnstyled = function SideBarUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme', 'shadow']),
      className = _omit.className,
      cssModule = _omit.cssModule,
      logoObject = _omit.logo,
      title = _omit.title,
      version = _omit.version,
      items = _omit.items,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "cssModule", "logo", "title", "version", "items"]);

  var logo = logoObject.logo,
      alt = logoObject.alt,
      href = logoObject.href,
      target = logoObject.target,
      restLogo = (0, _objectWithoutProperties2.default)(logoObject, ["logo", "alt", "href", "target"]);
  var logoComponent = logo ? _react.default.createElement(_Logo.default, {
    className: "logo-img"
  }, typeof logo === 'string' ? _react.default.createElement(_Img.default, (0, _extends2.default)({
    className: "logo-img",
    src: logo,
    alt: alt
  }, restLogo)) : logo) : null;
  return _react.default.createElement(_NavigationStyleguide.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'navigation'), cssModule)
  }, attributes), _react.default.createElement("div", {
    className: "navigation-logo"
  }, href && logo ? _react.default.createElement("a", {
    href: href,
    target: target
  }, logoComponent) : logoComponent, _react.default.createElement("p", {
    className: "navigation-title"
  }, title), version && _react.default.createElement(_Version.default, null, "v", version)), _react.default.createElement("div", {
    className: "font-weight-bold"
  }, items));
};

SideBarUnstyled.defaultProps = defaultProps;
SideBarUnstyled.propTypes = propTypes;
var SideBar = (0, _styledComponents.default)(SideBarUnstyled).withConfig({
  displayName: "SideBar",
  componentId: "m2e68v-0"
})(["", ""], function (props) {
  return "\n    &.navigation {      \n      ".concat(_breakpoints.default.up('xs', props.theme['$grid-breakpoints'], "\n        ".concat((0, _boxShadow.boxShadow)(props.shadow || props.theme['$enable-shadows'], props.theme.styleguide['$rsg-sidebar-box-shadow'].xs), "\n      ")), "\n      ").concat(_breakpoints.default.up('sm', props.theme['$grid-breakpoints'], "\n        ".concat((0, _boxShadow.boxShadow)(props.shadow || props.theme['$enable-shadows'], props.theme.styleguide['$rsg-sidebar-box-shadow'].sm), "\n      ")), "\n      .navigation-logo {\n        color: white;\n        background: ").concat(props.theme.styleguide['$rsg-sidebar-linear-gradient'], " !important;\n        padding: ").concat(props.theme.styleguide['$rsg-sidebar-logo-padding'], ";\n        text-align: ").concat(props.theme.styleguide['$rsg-sidebar-logo-align'], ";\n        .logo-img {\n          & svg {\n            height: ").concat(props.theme.styleguide['$rsg-sidebar-logo-svg-height'], ";\n            margin: ").concat(props.theme.styleguide['$rsg-sidebar-logo-svg-margin'], ";\n          }\n        }\n        .navigation-title {\n          line-height: ").concat(props.theme.styleguide['$rsg-sidebar-title-line-height'], ";\n          word-wrap: ").concat(props.theme.styleguide['$rsg-sidebar-title-word-wrap'], ";\n        }\n      }\n    }\n ");
});
SideBar.defaultProps = defaultProps;
SideBar.propTypes = propTypes;
/** @component */

var _default = SideBar;
exports.default = _default;