"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _breakpoints = _interopRequireDefault(require("@bootstrap-styled/css-mixins/lib/breakpoints"));

var _BootstrapProvider = _interopRequireDefault(require("@bootstrap-styled/provider/lib/BootstrapProvider"));

var _reactFontawesome = require("@fortawesome/react-fontawesome");

var _hover = require("@bootstrap-styled/css-mixins/lib/hover");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var _SideBar = _interopRequireDefault(require("../SideBar"));

var _FooterRenderer = _interopRequireDefault(require("../FooterRenderer"));

var _Ribbon = _interopRequireDefault(require("../Ribbon"));

require("../fontawesome.config");

var _theme = _interopRequireDefault(require("../theme"));

/* eslint-disable react/prop-types */
var defaultProps = {
  hasSidebar: true,
  theme: _theme.default,
  reset: true,
  injectGlobal: true,
  shadow: true,
  logoMenu: {
    logo: null,
    href: null,
    target: null,
    text: null,
    alt: null
  },
  logoFooter: {
    logo: null,
    height: null,
    href: null,
    target: null,
    text: null,
    alt: null
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** enable the shadow */
  shadow: _propTypes.default.bool,

  /** Set title used in `<SideBar />` component. */
  title: _propTypes.default.string.isRequired,

  /** @ignore */
  children: _propTypes.default.node.isRequired,

  /** An instance of TableOfContentsRenderer */
  toc: _propTypes.default.node.isRequired,

  /** Version of documentation. */
  version: _propTypes.default.string,

  /** Toggle sidebar style. */
  hasSidebar: _propTypes.default.bool,

  /** Logo attributes in order to render menu logo. */
  logoMenu: _propTypes.default.shape({
    logo: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
    href: _propTypes.default.string,
    target: _propTypes.default.string,
    text: _propTypes.default.string,
    alt: _propTypes.default.string
  }),

  /** Logo attributes in order to render footer logo. */
  logoFooter: _propTypes.default.shape({
    logo: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
    height: _propTypes.default.string,
    href: _propTypes.default.string,
    target: _propTypes.default.string,
    text: _propTypes.default.string,
    alt: _propTypes.default.string
  }),

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-styleguide-background-color': _propTypes.default.string,
      '$rsg-styleguide-has-sidebar-padding-left': _propTypes.default.shape({
        xs: _propTypes.default.string,
        sm: _propTypes.default.string,
        md: _propTypes.default.string,
        lg: _propTypes.default.string
      }),
      '$rsg-styleguide-content-max-width': _propTypes.default.string,
      '$rsg-styleguide-content-margin': _propTypes.default.string,
      '$rsg-styleguide-content-display': _propTypes.default.string,
      '$rsg-styleguide-no-print-display': _propTypes.default.string,
      '$rsg-styleguide-content-transition': _propTypes.default.string,
      '$rsg-styleguide-content-padding': _propTypes.default.shape({
        xs: _propTypes.default.string,
        lg: _propTypes.default.string
      }),
      '$rsg-styleguide-content-width': _propTypes.default.shape({
        md: _propTypes.default.string,
        lg: _propTypes.default.string
      }),
      '$rsg-styleguide-content-sidebar-open-transform': _propTypes.default.shape({
        md: _propTypes.default.string,
        lg: _propTypes.default.string
      }),
      '$rsg-styleguide-sidebar-z-index': _propTypes.default.string,
      '$rsg-styleguide-sidebar-transform': _propTypes.default.string,
      '$rsg-styleguide-sidebar-open-transition': _propTypes.default.string,
      '$rsg-styleguide-sidebar-open-transform': _propTypes.default.shape({
        md: _propTypes.default.string,
        lg: _propTypes.default.string
      }),
      '$rsg-styleguide-sidebar-close-transition': _propTypes.default.string,
      '$rsg-styleguide-sidebar-close-transform': _propTypes.default.shape({
        md: _propTypes.default.string,
        lg: _propTypes.default.string
      }),
      '$rsg-styleguide-sidebar-button-transform': _propTypes.default.string,
      '$rsg-styleguide-sidebar-button-padding': _propTypes.default.string,
      '$rsg-styleguide-sidebar-button-color': _propTypes.default.string,
      '$rsg-styleguide-sidebar-button-box-shadow': _propTypes.default.string,
      '$rsg-styleguide-sidebar-button-position': _propTypes.default.string,
      '$rsg-styleguide-sidebar-button-transition': _propTypes.default.string,
      '$rsg-styleguide-sidebar-button-hover-color': _propTypes.default.string,
      '$rsg-styleguide-sidebar-button-outline': _propTypes.default.string,
      '$rsg-styleguide-sidebar-button-visibility': _propTypes.default.shape({
        xs: _propTypes.default.string,
        md: _propTypes.default.string,
        lg: _propTypes.default.string
      }),
      '$rsg-styleguide-sidebar-open-button-transition': _propTypes.default.string,
      '$rsg-styleguide-sidebar-open-button-transform': _propTypes.default.string,
      '$rsg-styleguide-sidebar-close-button-transition': _propTypes.default.string,
      '$rsg-styleguide-sidebar-close-button-z-index': _propTypes.default.string,
      '$rsg-styleguide-sidebar-close-button-transform': _propTypes.default.shape({
        sm: _propTypes.default.string,
        md: _propTypes.default.string,
        lg: _propTypes.default.string
      })
    })
  }),
  reset: _propTypes.default.bool,
  injectGlobal: _propTypes.default.bool,

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

/**
 * The StyleGuideRenderer is the layout UI entrypoint. It is also described in react-styleguidist API with possibility to override using webpack alias.
 * You can use it to create your own StyleGuideRenderer. New layout can also be created from scracth, making infinite possibilities of customization
 * See: https://rollup-umd.github.io/documentation.
 */

exports.propTypes = propTypes;

var StyleGuideRendererUnstyled =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(StyleGuideRendererUnstyled, _Component);

  function StyleGuideRendererUnstyled() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, StyleGuideRendererUnstyled);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(StyleGuideRendererUnstyled)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      isOpenSidebar: false
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "toggleSideBar", function () {
      _this.setState({
        isOpenSidebar: !_this.state.isOpenSidebar
      });
    });
    return _this;
  }

  (0, _createClass2.default)(StyleGuideRendererUnstyled, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.state.isOpenSidebar !== nextState.isOpenSidebar || this.props.children !== nextProps.children;
    }
  }, {
    key: "render",
    value: function render() {
      var _omit = (0, _lodash.default)(this.props, ['homepageUrl', 'theme', 'injectGlobal', 'reset']),
          className = _omit.className,
          title = _omit.title,
          version = _omit.version,
          children = _omit.children,
          toc = _omit.toc,
          hasSidebar = _omit.hasSidebar,
          logoMenu = _omit.logoMenu,
          logoFooter = _omit.logoFooter,
          cssModule = _omit.cssModule,
          shadow = _omit.shadow,
          attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "title", "version", "children", "toc", "hasSidebar", "logoMenu", "logoFooter", "cssModule", "shadow"]);

      var isOpenSidebar = this.state.isOpenSidebar;
      return _react.default.createElement("div", (0, _extends2.default)({
        className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-styleguide', {
          'has-sidebar': hasSidebar
        }), cssModule)
      }, attributes), hasSidebar && _react.default.createElement("div", null, _react.default.createElement("div", {
        className: "sidebar-button ".concat(isOpenSidebar ? 'sidebar-open' : 'sidebar-close'),
        role: "button",
        tabIndex: "0",
        onClick: this.toggleSideBar,
        onKeyPress: this.toggleSideBar
      }, _react.default.createElement(_reactFontawesome.FontAwesomeIcon, {
        size: "lg",
        icon: ['fas', 'bars']
      })), _react.default.createElement(_SideBar.default, {
        className: "sidebar ".concat(isOpenSidebar ? 'sidebar-open' : 'sidebar-close'),
        version: version,
        logo: logoMenu,
        title: title,
        items: toc,
        shadow: shadow
      }), _react.default.createElement(_Ribbon.default, null)), _react.default.createElement("main", {
        className: "content ".concat(isOpenSidebar && hasSidebar ? 'sidebar-open' : 'sidebar-close')
      }, children, logoFooter.logo && _react.default.createElement(_FooterRenderer.default, {
        logo: logoFooter
      })));
    }
  }]);
  return StyleGuideRendererUnstyled;
}(_react.Component);

(0, _defineProperty2.default)(StyleGuideRendererUnstyled, "propTypes", propTypes);
(0, _defineProperty2.default)(StyleGuideRendererUnstyled, "defaultProps", defaultProps);
var StyleGuideRendererStyled = (0, _styledComponents.default)(StyleGuideRendererUnstyled).withConfig({
  displayName: "StyleGuideRenderer__StyleGuideRendererStyled",
  componentId: "sc-1hs4jur-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-styleguide {\n      @media print{\n         .no-print {\n             display: ".concat(props.theme.styleguide['$rsg-styleguide-no-print-display'], ";\n         }\n      }\n      background-color: ").concat(props.theme.styleguide['$rsg-styleguide-background-color'], ";\n      .content {\n        max-width: ").concat(props.theme.styleguide['$rsg-styleguide-content-max-width'], ";\n        margin: ").concat(props.theme.styleguide['$rsg-styleguide-content-margin'], ";\n        display: ").concat(props.theme.styleguide['$rsg-styleguide-content-display'], ";\n        transition: ").concat(props.theme.styleguide['$rsg-styleguide-content-transition'], ";\n  ").concat(_breakpoints.default.up('xs', props.theme['$grid-breakpoints'], "\n      padding: ".concat(props.theme.styleguide['$rsg-styleguide-content-padding'].xs, ";\n    ")), "\n  ").concat(_breakpoints.default.up('md', props.theme['$grid-breakpoints'], "\n      width: ".concat(props.theme.styleguide['$rsg-styleguide-content-width'].md, ";\n    ")), "\n  ").concat(_breakpoints.default.up('lg', props.theme['$grid-breakpoints'], "\n      width: ".concat(props.theme.styleguide['$rsg-styleguide-content-width'].lg, ";\n      padding: ").concat(props.theme.styleguide['$rsg-styleguide-content-padding'].lg, ";\n    ")), "\n      }\n    }\n    .content.sidebar-close {\n  ").concat(_breakpoints.default.up('md', props.theme['$grid-breakpoints'], "\n      transform: ".concat(props.theme.styleguide['$rsg-styleguide-content-sidebar-close-transform'], "\n    ")), " \n  }\n    &.has-sidebar {\n  ").concat(_breakpoints.default.up('xs', props.theme['$grid-breakpoints'], "\n      padding-left: ".concat(props.theme.styleguide['$rsg-styleguide-has-sidebar-padding-left'].xs, ";\n    ")), "\n  ").concat(_breakpoints.default.up('sm', props.theme['$grid-breakpoints'], "\n      padding-left: ".concat(props.theme.styleguide['$rsg-styleguide-has-sidebar-padding-left'].xs, ";\n    ")), "\n  ").concat(_breakpoints.default.up('md', props.theme['$grid-breakpoints'], "\n      padding-left: ".concat(props.theme.styleguide['$rsg-styleguide-has-sidebar-padding-left'].md, ";\n    ")), "\n  ").concat(_breakpoints.default.up('lg', props.theme['$grid-breakpoints'], "\n      padding-left: ".concat(props.theme.styleguide['$rsg-styleguide-has-sidebar-padding-left'].lg, ";\n    ")), "\n    }\n    & .sidebar {\n    z-index: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-z-index'], ";\n  ").concat(_breakpoints.default.up('lg', props.theme['$grid-breakpoints'], "\n      transform: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-transform'], ";\n    ")), "\n    }\n    & .sidebar.sidebar-open {\n    transition: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-open-transition'], ";\n  ").concat(_breakpoints.default.up('md', props.theme['$grid-breakpoints'], "\n      transform: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-open-transform'].md, ";\n    ")), "\n  ").concat(_breakpoints.default.up('lg', props.theme['$grid-breakpoints'], "\n      transform: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-open-transform'].lg, ";\n    ")), "\n    }\n    & .sidebar.sidebar-close {\n    transition: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-close-transition'], ";\n  ").concat(_breakpoints.default.up('md', props.theme['$grid-breakpoints'], "\n      transform: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-close-transform'].md, ";\n    ")), "\n  ").concat(_breakpoints.default.up('lg', props.theme['$grid-breakpoints'], "\n      transform: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-close-transform'].lg, ";\n    ")), "\n    }\n    & .sidebar-button {\n      transform: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-button-transform'], ";\n      padding: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-button-padding'], ";\n      color: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-button-color'], ";\n      box-shadow: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-button-box-shadow'], ";\n      position: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-button-position'], ";\n      transition: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-button-transition'], ";\n      top: 30px;\n      z-index: 4999;\n  ").concat((0, _hover.hover)("\n    color: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-button-hover-color'], ";\n  ")), " \n      &:focus, &:active {\n        outline: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-button-outline'], ";\n      }\n  ").concat(_breakpoints.default.up('xs', props.theme['$grid-breakpoints'], "\n      visibility: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-button-visibility'].xs, ";\n    ")), "\n  ").concat(_breakpoints.default.up('md', props.theme['$grid-breakpoints'], "\n      visibility: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-button-visibility'].md, ";\n    ")), "\n  ").concat(_breakpoints.default.up('lg', props.theme['$grid-breakpoints'], "\n      visibility: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-button-visibility'].lg, ";\n    ")), "\n    }\n    & .sidebar-button.sidebar-open {\n    transition: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-open-button-transition'], ";\n  ").concat(_breakpoints.default.up('md', props.theme['$grid-breakpoints'], "\n      transform: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-open-button-transform'], ";\n      color: white;\n    ")), "\n    }\n    & .sidebar-button.sidebar-close {\n    transition: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-close-button-transition'], ";\n ").concat(_breakpoints.default.down('sm', props.theme['$grid-breakpoints'], "\n      z-index: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-close-button-z-index'], ";\n      transform: ").concat(props.theme.styleguide['$rsg-styleguide-sidebar-close-button-transform'].sm, ";\n    ")), "\n  ").concat(_breakpoints.default.up('md', props.theme['$grid-breakpoints'], "\n      transform: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-close-button-transform'].md, ";\n    ")), "\n  ").concat(_breakpoints.default.up('lg', props.theme['$grid-breakpoints'], "\n      transform: ".concat(props.theme.styleguide['$rsg-styleguide-sidebar-close-button-transform'].lg, ";\n    ")), "\n    }\n ");
});
StyleGuideRendererStyled.defaultProps = defaultProps;
StyleGuideRendererStyled.propTypes = propTypes;

var StyleGuideRenderer =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(StyleGuideRenderer, _React$Component);

  function StyleGuideRenderer() {
    (0, _classCallCheck2.default)(this, StyleGuideRenderer);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf3.default)(StyleGuideRenderer).apply(this, arguments));
  }

  (0, _createClass2.default)(StyleGuideRenderer, [{
    key: "render",
    // eslint-disable-line react/prefer-stateless-function, react/no-multi-comp
    value: function render() {
      var _this$props = this.props,
          theme = _this$props.theme,
          reset = _this$props.reset,
          injectGlobal = _this$props.injectGlobal,
          rest = (0, _objectWithoutProperties2.default)(_this$props, ["theme", "reset", "injectGlobal"]);
      return _react.default.createElement(_BootstrapProvider.default, {
        theme: theme,
        reset: reset,
        injectGlobal: injectGlobal
      }, _react.default.createElement(StyleGuideRendererStyled, rest));
    }
  }]);
  return StyleGuideRenderer;
}(_react.default.Component);

StyleGuideRenderer.defaultProps = defaultProps;
StyleGuideRenderer.propTypes = propTypes;
var _default = StyleGuideRenderer;
exports.default = _default;