"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _StyleGuideRenderer = _interopRequireDefault(require("../StyleGuideRenderer"));

/* eslint-disable */

/**
 * Testing our StyleGuideRenderer component
 */
var children = _react.default.createElement("h1", null, "Test");

var renderComponent = function renderComponent() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return (0, _enzyme.shallow)(_react.default.createElement(_StyleGuideRenderer.default, props, children));
};

describe('<StyleGuideRenderer />', function () {
  var title;
  var homepageUrl;
  var toc;
  beforeAll(function () {
    title = 'Title';
    homepageUrl = 'https://bootstrap-styled.github.io/rsg-components';
    toc = _react.default.createElement("a", null, "table of content link");
  });
  it('should render an StyleGuideRenderer with children', function () {
    var renderedComponent = renderComponent({
      title: title,
      homepageUrl: homepageUrl,
      toc: toc
    });
    expect(renderedComponent.contains(children)).toEqual(true);
  });
});