"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Button = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Button"));

var _hover = require("@bootstrap-styled/css-mixins/lib/hover");

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-tab-button-padding': '8px 0 8px 0',
      '$rsg-tab-button-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif',
      '$rsg-tab-button-font-size': '15px',
      '$rsg-tab-button-color': '#767676',
      '$rsg-tab-button-background': 'transparent',
      '$rsg-tab-button-text-transform': 'uppercase',
      '$rsg-tab-button-transition': 'color 750ms ease-out',
      '$rsg-tab-button-border': 'none',
      '$rsg-tab-button-cursor': 'pointer',
      '$rsg-tab-button-box-shadow': 'none',
      '$rsg-tab-button-hover-focus-isolate': 'false',
      '$rsg-tab-button-hover-focus-outline': '0',
      '$rsg-tab-button-hover-focus-color': '#f28a25',
      '$rsg-tab-button-hover-focus-transition': 'color 150ms ease-in',
      '$rsg-tab-button-focus-not-active-isolate': 'auto',
      '$rsg-tab-button-focus-not-active-outline': '0',
      '$rsg-tab-button-children-isolate': 'auto',
      '$rsg-tab-button-children-margin-left': '8px',
      '$rsg-tab-button-border-bottom': '2px #f28a25 solid'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Display button name. */
  visibleName: _propTypes.default.string,

  /** Set function passed to onclick button event. */
  onClick: _propTypes.default.func,

  /** Toggle button active style. */
  active: _propTypes.default.bool,

  /** Specified node element will be passed as children of `<TabButtonRenderer />` component. */
  children: _propTypes.default.node,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-tab-button-padding': _propTypes.default.string,
      '$rsg-tab-button-font-family': _propTypes.default.string,
      '$rsg-tab-button-font-size': _propTypes.default.string,
      '$rsg-tab-button-color': _propTypes.default.string,
      '$rsg-tab-button-background': _propTypes.default.string,
      '$rsg-tab-button-text-transform': _propTypes.default.string,
      '$rsg-tab-button-transition': _propTypes.default.string,
      '$rsg-tab-button-border': _propTypes.default.string,
      '$rsg-tab-button-cursor': _propTypes.default.string,
      '$rsg-tab-button-box-shadow': _propTypes.default.string,
      '$rsg-tab-button-hover-focus-isolate': _propTypes.default.string,
      '$rsg-tab-button-hover-focus-outline': _propTypes.default.string,
      '$rsg-tab-button-hover-focus-color': _propTypes.default.string,
      '$rsg-tab-button-hover-focus-transition': _propTypes.default.string,
      '$rsg-tab-button-focus-not-active-isolate': _propTypes.default.string,
      '$rsg-tab-button-focus-not-active-outline': _propTypes.default.string,
      '$rsg-tab-button-children-isolate': _propTypes.default.string,
      '$rsg-tab-button-children-margin-left': _propTypes.default.string,
      '$rsg-tab-button-border-bottom': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var TabButtonRendererUnstyled = function TabButtonRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme', 'pathLine', 'hasExamples', 'filepath', 'slug', 'module', 'props', 'metadata', 'name']),
      className = _omit.className,
      visibleName = _omit.visibleName,
      onClick = _omit.onClick,
      active = _omit.active,
      children = _omit.children,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "visibleName", "onClick", "active", "children", "cssModule"]);

  return _react.default.createElement(_Button.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-tab-button rounded-bottom-0', {
      active: active
    }), cssModule)
  }, attributes, {
    name: visibleName,
    onClick: onClick,
    color: "secondary"
  }), children);
};

TabButtonRendererUnstyled.defaultProps = defaultProps;
TabButtonRendererUnstyled.propTypes = propTypes;
var TabButtonRenderer = (0, _styledComponents.default)(TabButtonRendererUnstyled).withConfig({
  displayName: "TabButtonRenderer",
  componentId: "sc-1rqdnhn-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-tab-button {\n      padding: ".concat(props.theme.styleguide['$rsg-tab-button-padding'], ";\n      font-family: ").concat(props.theme.styleguide['$rsg-tab-button-font-family'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-tab-button-font-size'], ";\n      color: ").concat(props.theme.styleguide['$rsg-tab-button-color'], ";\n      background: ").concat(props.theme.styleguide['$rsg-tab-button-background'], ";\n      text-transform: ").concat(props.theme.styleguide['$rsg-tab-button-text-transform'], ";\n      transition: ").concat(props.theme.styleguide['$rsg-tab-button-transition'], ";\n      border: ").concat(props.theme.styleguide['$rsg-tab-button-border'], ";\n      cursor: ").concat(props.theme.styleguide['$rsg-tab-button-cursor'], ";\n      box-shadow: ").concat(props.theme.styleguide['$rsg-tab-button-box-shadow'], " !important;\n  ").concat((0, _hover.hoverFocus)(props.theme['$enable-hover-media-query'], "\n      isolation: ".concat(props.theme.styleguide['$rsg-tab-button-hover-focus-isolate'], ";\n      outline: ").concat(props.theme.styleguide['$rsg-tab-button-hover-focus-outline'], ";\n      color: ").concat(props.theme.styleguide['$rsg-tab-button-hover-focus-color'], ";\n      transition: ").concat(props.theme.styleguide['$rsg-tab-button-hover-focus-transition'], ";\n\n    ")), " \n      &:focus:not($active) {\n        isolation: ").concat(props.theme.styleguide['$rsg-tab-button-focus-not-active-isolate'], ";\n        outline: ").concat(props.theme.styleguide['$rsg-tab-button-focus-not-active-outline'], ";\n      }     \n      & + & {\n        isolation: ").concat(props.theme.styleguide['$rsg-tab-button-children-isolate'], ";\n        margin-left: ").concat(props.theme.styleguide['$rsg-tab-button-children-margin-left'], ";\n      }          \n    }\n    &.rsg-tab-button.active {\n      border-bottom: ").concat(props.theme.styleguide['$rsg-tab-button-border-bottom'], ";\n    }\n ");
});
TabButtonRenderer.defaultProps = defaultProps;
TabButtonRenderer.propTypes = propTypes;
/** @component */

var _default = TabButtonRenderer;
exports.default = _default;