"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Table = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table"));

var _Thead = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Thead"));

var _Tr = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Tr"));

var _Th = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Th"));

var _Tbody = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Tbody"));

var _Td = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Table/Td"));

var _Strong = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Strong"));

var _breakpoints = _interopRequireDefault(require("@bootstrap-styled/css-mixins/lib/breakpoints"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-table-border': 'none',
      '$rsg-table-layout': {
        xs: 'fixed',
        md: 'fixed',
        xxl: 'auto'
      },
      '$rsg-table-width': {
        xs: '100%',
        md: 'fixed',
        xxl: '1000px'
      },
      '$rsg-table-th-width': {
        xs: '21.6666666667%;',
        md: '18.3333333333%',
        xxl: '81.48148148px'
      },
      '$rsg-table-th-last-width': {
        xs: '35%',
        md: '45%',
        xxl: '200px'
      },
      '$rsg-table-td-width': {
        xs: '21.6666666667%',
        md: '18.3333333333%',
        xxl: '81.48148148px'
      },
      '$rsg-table-td-last-width': {
        xs: '35%',
        md: '45%',
        xxl: '200px'
      },
      '$rsg-table-cell-heading-vertical-align': 'text-top',
      '$rsg-table-cell-heading-first-child-white-space': 'pre-wrap',
      '$rsg-table-cell-heading-font-size': {
        xs: '12px',
        sm: '15px'
      },
      '$rsg-table-cell-padding': '5px 5px 7px 0',
      '$rsg-table-cell-font-size': {
        xs: '12px',
        sm: '15px'
      },
      '$rsg-table-cell-span-font-size': {
        xs: '12px',
        sm: '15px'
      },
      '$rsg-table-overflow': 'auto',
      '$rsg-table-border-collapse': 'collapse',
      '$rsg-table-margin': '24px 0 0 0',
      '$rsg-table-head-border-bottom': '1px #e8e8e8 solid',
      '$rsg-table-cell-heading-color': '#333',
      '$rsg-table-cell-heading-padding': '0 8px 4px 0',
      '$rsg-table-cell-heading-text-align': 'left',
      '$rsg-table-cell-heading-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif',
      '$rsg-table-cell-heading-font-weight': 'bold',
      '$rsg-table-cell-heading-white-space': 'nowrap',
      '$rsg-table-cell-border-top': '0',
      '$rsg-table-cell-color': '#333',
      '$rsg-table-cell-vertical-align': 'top',
      '$rsg-table-cell-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif',
      '$rsg-table-cell-child-isolation': 'false',
      '$rsg-table-cell-child-p-isolation': 'false',
      '$rsg-table-cell-child-p-margin': '0 0 0 0'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Columns to be rendered. */
  columns: _propTypes.default.arrayOf(_propTypes.default.shape({
    caption: _propTypes.default.string.isRequired,
    render: _propTypes.default.func.isRequired
  })).isRequired,

  /** Rows to be rendered. */
  rows: _propTypes.default.arrayOf(_propTypes.default.object).isRequired,

  /** Set function passed to `<Tr />` component. */
  getRowKey: _propTypes.default.func.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-table-border': _propTypes.default.string,
      '$rsg-table-layout': _propTypes.default.shape({
        xs: _propTypes.default.string,
        md: _propTypes.default.string,
        xxl: _propTypes.default.string
      }),
      '$rsg-table-width': _propTypes.default.shape({
        xs: _propTypes.default.string,
        md: _propTypes.default.string,
        xxl: _propTypes.default.string
      }),
      '$rsg-table-th-width': _propTypes.default.shape({
        xs: _propTypes.default.string,
        md: _propTypes.default.string,
        xxl: _propTypes.default.string
      }),
      '$rsg-table-th-last-width': _propTypes.default.shape({
        xs: _propTypes.default.string,
        md: _propTypes.default.string,
        xxl: _propTypes.default.string
      }),
      '$rsg-table-td-width': _propTypes.default.shape({
        xs: _propTypes.default.string,
        md: _propTypes.default.string,
        xxl: _propTypes.default.string
      }),
      '$rsg-table-td-last-width': _propTypes.default.shape({
        xs: _propTypes.default.string,
        md: _propTypes.default.string,
        xxl: _propTypes.default.string
      }),
      '$rsg-table-cell-heading-vertical-align': _propTypes.default.string,
      '$rsg-table-cell-heading-first-child-white-space': _propTypes.default.string,
      '$rsg-table-cell-heading-font-size': _propTypes.default.shape({
        xs: _propTypes.default.string,
        sm: _propTypes.default.string
      }),
      '$rsg-table-cell-padding': _propTypes.default.string,
      '$rsg-table-cell-font-size': _propTypes.default.shape({
        xs: _propTypes.default.string,
        sm: _propTypes.default.string
      }),
      '$rsg-table-cell-span-font-size': _propTypes.default.shape({
        xs: _propTypes.default.string,
        sm: _propTypes.default.string
      }),
      '$rsg-table-overflow': _propTypes.default.string,
      '$rsg-table-border-collapse': _propTypes.default.string,
      '$rsg-table-margin': _propTypes.default.string,
      '$rsg-table-head-border-bottom': _propTypes.default.string,
      '$rsg-table-cell-heading-color': _propTypes.default.string,
      '$rsg-table-cell-heading-padding': _propTypes.default.string,
      '$rsg-table-cell-heading-text-align': _propTypes.default.string,
      '$rsg-table-cell-heading-font-family': _propTypes.default.string,
      '$rsg-table-cell-heading-font-weight': _propTypes.default.string,
      '$rsg-table-cell-heading-white-space': _propTypes.default.string,
      '$rsg-table-cell-border-top': _propTypes.default.string,
      '$rsg-table-cell-color': _propTypes.default.string,
      '$rsg-table-cell-vertical-align': _propTypes.default.string,
      '$rsg-table-cell-font-family': _propTypes.default.string,
      '$rsg-table-cell-child-isolation': _propTypes.default.string,
      '$rsg-table-cell-child-p-isolation': _propTypes.default.string,
      '$rsg-table-cell-child-p-margin': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var TableRendererUnstyled = function TableRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      columns = _omit.columns,
      rows = _omit.rows,
      getRowKey = _omit.getRowKey,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "columns", "rows", "getRowKey", "cssModule"]);
  /* eslint-disable react/no-array-index-key */


  return _react.default.createElement(_Table.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-table'), cssModule)
  }, attributes), _react.default.createElement(_Thead.default, {
    className: "rsg-table-head"
  }, _react.default.createElement(_Tr.default, {
    className: "rsg-table-row"
  }, columns.map(function (_ref) {
    var caption = _ref.caption;
    return _react.default.createElement(_Th.default, {
      key: caption,
      className: "rsg-table-cell-heading"
    }, _react.default.createElement(_Strong.default, {
      className: "rsg-table-cell-heading-content"
    }, caption));
  }))), _react.default.createElement(_Tbody.default, {
    className: "rsg-table-body"
  }, rows.map(function (row) {
    return _react.default.createElement(_Tr.default, {
      key: getRowKey(row),
      className: "rsg-table-row"
    }, columns.map(function (_ref2, index) {
      var render = _ref2.render;
      return _react.default.createElement(_Td.default, {
        key: "rsg-table-cell-".concat(index),
        className: "rsg-table-cell"
      }, render(row));
    }));
  })));
  /* eslint-enable react/no-array-index-key */
};

TableRendererUnstyled.defaultProps = defaultProps;
TableRendererUnstyled.propTypes = propTypes;
var TableRenderer = (0, _styledComponents.default)(TableRendererUnstyled).withConfig({
  displayName: "TableRenderer",
  componentId: "y47duq-0"
})(["", ""], function (props) {
  return "\n    &.rsg-table {\n      border: ".concat(props.theme.styleguide['$rsg-table-border'], ";\n  ").concat(_breakpoints.default.up('xs', props.theme['$grid-breakpoints'], "\n      table-layout: ".concat(props.theme.styleguide['$rsg-table-layout'].xs, ";\n      width: ").concat(props.theme.styleguide['$rsg-table-width'].xs, ";\n    ")), "\n  ").concat(_breakpoints.default.up('xxl', {
    xxl: '1500px'
  }, "\n      table-layout:  ".concat(props.theme.styleguide['$rsg-table-layout'].xxl, ";\n      width: ").concat(props.theme.styleguide['$rsg-table-width'].xxl, ";\n    ")), "\n      overflow: ").concat(props.theme.styleguide['$rsg-table-overflow'], ";\n      border-collapse: ").concat(props.theme.styleguide['$rsg-table-border-collapse'], " !important;\n      margin: ").concat(props.theme.styleguide['$rsg-table-margin'], ";\n  ").concat(_breakpoints.default.up('xs', props.theme['$grid-breakpoints'], "\n      thead tr th:not(:last-child) {\n        width: ".concat(props.theme.styleguide['$rsg-table-th-width'].xs, ";\n      }\n      thead tr th:last-child {\n        width: ").concat(props.theme.styleguide['$rsg-table-th-last-width'].xs, ";\n      }\n      tbody tr td:not(:last-child) {\n        width: ").concat(props.theme.styleguide['$rsg-table-td-width'].xs, ";\n      }\n      tbody tr td:last-child {\n        width: ").concat(props.theme.styleguide['$rsg-table-td-last-width'].xs, ";\n      }\n    ")), "\n  ").concat(_breakpoints.default.up('md', props.theme['$grid-breakpoints'], "\n      thead tr th:not(:last-child) {\n        width: ".concat(props.theme.styleguide['$rsg-table-th-width'].md, ";\n      }\n      thead tr th:last-child {\n        width: ").concat(props.theme.styleguide['$rsg-table-th-last-width'].md, ";\n      }\n      tbody tr td:not(:last-child) {\n        width: ").concat(props.theme.styleguide['$rsg-table-td-width'].md, ";\n      }\n      tbody tr td:last-child {\n        width: ").concat(props.theme.styleguide['$rsg-table-td-last-width'].md, ";\n      }\n    ")), "\n  ").concat(_breakpoints.default.up('xxl', {
    xxl: '1500px'
  }, "\n      thead tr th:not(:last-child) {\n        width: ".concat(props.theme.styleguide['$rsg-table-th-width'].xxl, ";\n      }\n      thead tr th:last-child {\n        width: ").concat(props.theme.styleguide['$rsg-table-th-last-width'].xxl, ";\n      }\n      tbody tr td:not(:last-child) {\n        width: ").concat(props.theme.styleguide['$rsg-table-td-width'].xxl, ";\n      }\n      tbody tr td:last-child {\n        width: ").concat(props.theme.styleguide['$rsg-table-td-last-width'].xxl, ";\n      }\n    ")), "\n      .rsg-table-head {\n        border-bottom: ").concat(props.theme.styleguide['$rsg-table-head-border-bottom'], ";\n        & .rsg-table-cell-heading {\n          padding: ").concat(props.theme.styleguide['$rsg-table-cell-heading-padding'], ";\n          color: ").concat(props.theme.styleguide['$rsg-table-cell-heading-color'], ";\n          text-align: ").concat(props.theme.styleguide['$rsg-table-cell-heading-text-align'], ";\n          font-weight: ").concat(props.theme.styleguide['$rsg-table-cell-heading-font-weight'], ";\n          font-family: ").concat(props.theme.styleguide['$rsg-table-cell-heading-font-family'], ";\n  ").concat(_breakpoints.default.up('xs', props.theme['$grid-breakpoints'], "\n      font-size: ".concat(props.theme.styleguide['$rsg-table-cell-heading-font-size'].xs, ";\n    ")), "\n  ").concat(_breakpoints.default.up('sm', props.theme['$grid-breakpoints'], "\n     font-size: ".concat(props.theme.styleguide['$rsg-table-cell-heading-font-size'].xs, ";\n    ")), "\n          white-space: ").concat(props.theme.styleguide['$rsg-table-cell-heading-white-space'], ";\n          vertical-align: ").concat(props.theme.styleguide['$rsg-table-cell-heading-vertical-align'], ";\n          &:first-child {\n            white-space: ").concat(props.theme.styleguide['$rsg-table-cell-heading-first-child-white-space'], ";\n          }\n        }\n      }\n      & .rsg-table-cell {\n        padding: ").concat(props.theme.styleguide['$rsg-table-cell-padding'], ";\n        border-top: ").concat(props.theme.styleguide['$rsg-table-cell-border-top'], ";\n        color: ").concat(props.theme.styleguide['$rsg-table-cell-color'], ";\n        vertical-align: ").concat(props.theme.styleguide['$rsg-table-cell-vertical-align'], ";\n        font-family: ").concat(props.theme.styleguide['$rsg-table-cell-font-family'], ";\n  ").concat(_breakpoints.default.up('xs', props.theme['$grid-breakpoints'], "\n     font-size: ".concat(props.theme.styleguide['$rsg-table-cell-font-size'].xs, ";\n\n    ")), "\n  ").concat(_breakpoints.default.up('sm', props.theme['$grid-breakpoints'], "\n     font-size: ".concat(props.theme.styleguide['$rsg-table-cell-font-size'].sm, ";\n\n    ")), "\n        & span {\n  ").concat(_breakpoints.default.up('xs', props.theme['$grid-breakpoints'], "\n     font-size: ".concat(props.theme.styleguide['$rsg-table-cell-span-font-size'].xs, ";\n\n    ")), "\n  ").concat(_breakpoints.default.up('sm', props.theme['$grid-breakpoints'], "\n     font-size: ".concat(props.theme.styleguide['$rsg-table-cell-span-font-size'].sm, ";\n\n    ")), "\n        }\n        &:last-child {\n          isolation: ").concat(props.theme.styleguide['$rsg-table-cell-child-isolation'], ";\n        }\n        & p:last-child {\n          isolation: ").concat(props.theme.styleguide['$rsg-table-cell-child-p-isolation'], " !important;\n          margin: ").concat(props.theme.styleguide['$rsg-table-cell-child-p-margin'], ";\n        }\n      }\n    }\n ");
});
TableRenderer.defaultProps = defaultProps;
TableRenderer.propTypes = propTypes;
/** @component */

var _default = TableRenderer;
exports.default = _default;