"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Button = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Button"));

var _P = _interopRequireDefault(require("@bootstrap-styled/v4/lib/P"));

var _reactFontawesome = require("@fortawesome/react-fontawesome");

var _filterSectionsByName = _interopRequireDefault(require("react-styleguidist/lib/utils/filterSectionsByName"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _TableOfContentsRenderer = _interopRequireDefault(require("./TableOfContentsRenderer"));

var _ComponentsList = _interopRequireDefault(require("../ComponentsList"));

/* eslint-disable react/prop-types */
var defaultProps = {
  // eslint-disable-next-line react/default-props-match-prop-types
  theme: {
    styleguide: {
      '$rsg-toc-collapse-button-delay': '500',
      '$rsg-toc-collapse-button-cursor': 'pointer',
      '$rsg-toc-collapse-button-color': '#767676',
      '$rsg-toc-collapse-button-background': '#f4e2e1',
      '$rsg-toc-collapse-button-width': '100%',
      '$rsg-toc-collapse-button-height': '45px',
      '$rsg-toc-collapse-button-border-radius': '0',
      '$rsg-toc-collapse-button-active-box-shadow': 'none',
      '$rsg-toc-collapse-button-content-text-align': 'right',
      '$rsg-toc-collapse-button-content-icon-padding': '0 0 0 10px',
      '$rsg-toc-collapse-button-content-icon-transition': 'transform 1s',
      '$rsg-toc-collapse-button-content-icon-transform': 'translateY(2px) rotateX(180deg)'
    }
  },
  useRouterLinks: false
};
exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props
  sections: _propTypes.default.array.isRequired,
  useRouterLinks: _propTypes.default.bool,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-toc-collapse-button-delay': _propTypes.default.string,
      '$rsg-toc-collapse-button-cursor': _propTypes.default.string,
      '$rsg-toc-collapse-button-color': _propTypes.default.string,
      '$rsg-toc-collapse-button-background': _propTypes.default.string,
      '$rsg-toc-collapse-button-width': _propTypes.default.string,
      '$rsg-toc-collapse-button-height': _propTypes.default.string,
      '$rsg-toc-collapse-button-border-radius': _propTypes.default.string,
      '$rsg-toc-collapse-button-active-box-shadow': _propTypes.default.string,
      '$rsg-toc-collapse-button-content-text-align': _propTypes.default.string,
      '$rsg-toc-collapse-button-content-icon-padding': _propTypes.default.string,
      '$rsg-toc-collapse-button-content-icon-transition': _propTypes.default.string,
      '$rsg-toc-collapse-button-content-icon-transform': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
exports.propTypes = propTypes;
var isCollapseTransitioning = false;

var TableOfContentsUnstyled =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(TableOfContentsUnstyled, _Component);

  function TableOfContentsUnstyled() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, TableOfContentsUnstyled);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(TableOfContentsUnstyled)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      searchTerm: '',
      hasCollapse: false,
      isOpenCollapse: false
    });
    return _this;
  }

  (0, _createClass2.default)(TableOfContentsUnstyled, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      this.props.sections.map(function (section) {
        var children = [].concat((0, _toConsumableArray2.default)(section.sections || []), (0, _toConsumableArray2.default)(section.components || []));

        _this2.setState({
          hasCollapse: children.length > 0
        });

        return null;
      });
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextState) {
      return this.state.isOpenCollapse !== nextState.isOpenCollapse || this.state.searchTerm !== nextState.searchTerm;
    }
  }, {
    key: "onChangeCollapse",
    value: function onChangeCollapse() {
      if (!isCollapseTransitioning) {
        isCollapseTransitioning = true;
        this.setState({
          isOpenCollapse: !this.state.isOpenCollapse
        });
        setTimeout(function () {
          isCollapseTransitioning = false;
        }, this.props.theme.styleguide['$rsg-toc-collapse-button-delay']);
      }
    }
  }, {
    key: "renderLevel",
    value: function renderLevel(sections) {
      var _this3 = this;

      var useRouterLinks = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var hashPath = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
      var useHashId = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      var isOpenCollapse = this.state.isOpenCollapse;
      var items = sections.map(function (section) {
        var children = [].concat((0, _toConsumableArray2.default)(section.sections || []), (0, _toConsumableArray2.default)(section.components || []));
        var sectionDepth = section.sectionDepth || 0;
        var childHashPath = sectionDepth === 0 && useHashId ? hashPath : [].concat((0, _toConsumableArray2.default)(hashPath), [section.name]);
        return Object.assign({}, section, {
          heading: !!section.name && children.length > 0,
          content: children.length > 0 && _this3.renderLevel(children, useRouterLinks, childHashPath, sectionDepth === 0),
          collapse: isOpenCollapse
        });
      });
      return _react.default.createElement(_ComponentsList.default, {
        items: items,
        hashPath: hashPath,
        useHashId: useHashId,
        useRouterLinks: useRouterLinks,
        isOpenCollapse: isOpenCollapse
      });
    }
  }, {
    key: "renderSections",
    value: function renderSections() {
      var searchTerm = this.state.searchTerm;
      var _this$props = this.props,
          sections = _this$props.sections,
          useRouterLinks = _this$props.useRouterLinks; // If there is only one section, we treat it as a root section
      // In this case the name of the section won't be rendered and it won't get left padding

      var firstLevel = sections.length === 1 ? sections[0].components : sections;
      var filtered = (0, _filterSectionsByName.default)(firstLevel, searchTerm);
      return this.renderLevel(filtered, useRouterLinks);
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _omit = (0, _lodash.default)(this.props, ['theme', 'useRouterLinks', 'sections']),
          className = _omit.className,
          cssModule = _omit.cssModule,
          attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "cssModule"]);

      var _this$state = this.state,
          searchTerm = _this$state.searchTerm,
          hasCollapse = _this$state.hasCollapse,
          isOpenCollapse = _this$state.isOpenCollapse;
      return _react.default.createElement(_TableOfContentsRenderer.default, (0, _extends2.default)({
        className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-toc'), cssModule),
        searchTerm: searchTerm,
        onSearchTermChange: function onSearchTermChange(searchTerm) {
          return _this4.setState({
            searchTerm: searchTerm
          });
        } // eslint-disable-line no-shadow

      }, attributes), hasCollapse && _react.default.createElement(_Button.default, {
        className: "collapse-button no-print",
        onClick: function onClick() {
          return _this4.onChangeCollapse();
        }
      }, _react.default.createElement("div", {
        className: "collapse-button-content"
      }, _react.default.createElement(_P.default, null, isOpenCollapse ? 'Collapse all' : 'Expand all', _react.default.createElement(_reactFontawesome.FontAwesomeIcon, {
        className: "collapse-button-content-icon ".concat(!isOpenCollapse ? 'no-collapse' : ''),
        size: "lg",
        icon: ['fas', 'angle-up']
      })))), this.renderSections());
    }
  }]);
  return TableOfContentsUnstyled;
}(_react.Component);

(0, _defineProperty2.default)(TableOfContentsUnstyled, "propTypes", propTypes);
(0, _defineProperty2.default)(TableOfContentsUnstyled, "defaultProps", defaultProps);
var TableOfContents = (0, _styledComponents.default)(TableOfContentsUnstyled).withConfig({
  displayName: "TableOfContents",
  componentId: "sc-1gbxp5g-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-toc {\n      .collapse-button {\n        cursor: ".concat(props.theme.styleguide['$rsg-toc-collapse-button-cursor'], ";\n        color: ").concat(props.theme.styleguide['$rsg-toc-collapse-button-color'], ";\n        background: ").concat(props.theme.styleguide['$rsg-toc-collapse-button-background'], ";\n        width: ").concat(props.theme.styleguide['$rsg-toc-collapse-button-width'], ";\n        height: ").concat(props.theme.styleguide['$rsg-toc-collapse-button-height'], ";\n        border-radius: ").concat(props.theme.styleguide['$rsg-toc-collapse-button-border-radius'], ";\n        &:focus, &:active {\n          box-shadow: ").concat(props.theme.styleguide['$rsg-toc-collapse-button-active-box-shadow'], ";\n        }\n        .collapse-button-content {\n          padding: 2px 0 0 0;\n          text-align: ").concat(props.theme.styleguide['$rsg-toc-collapse-button-content-text-align'], ";\n          .collapse-button-content-icon {\n            padding: ").concat(props.theme.styleguide['$rsg-toc-collapse-button-content-icon-padding'], ";\n            transition: ").concat(props.theme.styleguide['$rsg-toc-collapse-button-content-icon-transition'], ";\n          }\n          .collapse-button-content-icon.no-collapse {\n            transform: ").concat(props.theme.styleguide['$rsg-toc-collapse-button-content-icon-transform'], ";\n          }\n        }\n      }\n    }\n ");
});
TableOfContents.defaultProps = defaultProps;
TableOfContents.propTypes = propTypes;
/** @component */

var _default = TableOfContents;
exports.default = _default;