"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _Nav = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Nav"));

var _Form = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Form"));

var _Input = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Input"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-toc-display': 'block',
      '$rsg-toc-padding': '0',
      '$rsg-toc-background': '#fff',
      '$rsg-toc-text-align': 'left',
      '$rsg-toc-form-background': '#B31255',
      '$rsg-toc-form-padding': '20px 14px',
      '$rsg-toc-form-width': '100%',
      '$rsg-toc-form-margin': '0 auto'
    }
  }
};
exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Specified node element will be passed as children of `<TableOfContentsRenderer />` component. */
  children: _propTypes.default.node,
  // eslint-disable-line react/require-default-props

  /** Display search term used in search `<Input />` component. */
  searchTerm: _propTypes.default.string.isRequired,

  /** Set function passed to onchange input event. */
  onSearchTermChange: _propTypes.default.func.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-toc-display': _propTypes.default.string,
      '$rsg-toc-padding': _propTypes.default.string,
      '$rsg-toc-background': _propTypes.default.string,
      '$rsg-toc-text-align': _propTypes.default.string,
      '$rsg-toc-form-background': _propTypes.default.string,
      '$rsg-toc-form-padding': _propTypes.default.string,
      '$rsg-toc-form-width': _propTypes.default.string,
      '$rsg-toc-form-margin': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
exports.propTypes = propTypes;

var TableOfContentsRendererUnstyled = function TableOfContentsRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      searchTerm = _omit.searchTerm,
      onSearchTermChange = _omit.onSearchTermChange,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "searchTerm", "onSearchTermChange", "cssModule"]);

  return _react.default.createElement("div", (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-toc'), cssModule)
  }, attributes), _react.default.createElement(_Form.default, {
    className: "rsg-toc-form"
  }, _react.default.createElement(_Input.default, {
    className: "rsg-toc-form-input no-print",
    type: "text",
    size: "sm",
    value: searchTerm,
    placeholder: "Filter by name",
    "aria-label": "Filter by name",
    onChange: function onChange(event) {
      return onSearchTermChange(event.target.value);
    }
  })), _react.default.createElement(_Nav.default, {
    className: "rsg-toc-nav"
  }, children));
};

TableOfContentsRendererUnstyled.defaultProps = defaultProps;
TableOfContentsRendererUnstyled.propTypes = propTypes;
var TableOfContentsRenderer = (0, _styledComponents.default)(TableOfContentsRendererUnstyled).withConfig({
  displayName: "TableOfContentsRenderer",
  componentId: "g119rx-0"
})(["", ""], function (props) {
  return "\n    &.rsg-toc {\n      .rsg-toc-form {\n        background: ".concat(props.theme.styleguide['$rsg-toc-form-background'], ";\n        padding: ").concat(props.theme.styleguide['$rsg-toc-form-padding'], ";\n        .rsg-toc-form-input {\n          width: ").concat(props.theme.styleguide['$rsg-toc-form-width'], ";\n          margin: ").concat(props.theme.styleguide['$rsg-toc-form-margin'], ";\n        }\n      }\n      .rsg-toc-nav {\n        background: ").concat(props.theme.styleguide['$rsg-toc-background'], ";\n        text-align: ").concat(props.theme.styleguide['$rsg-toc-text-align'], ";\n        display: ").concat(props.theme.styleguide['$rsg-toc-display'], ";\n        padding: ").concat(props.theme.styleguide['$rsg-toc-padding'], ";\n      }\n    }\n  ");
});
TableOfContentsRenderer.defaultProps = defaultProps;
TableOfContentsRenderer.propTypes = propTypes;
/** @component */

var _default = TableOfContentsRenderer;
exports.default = _default;