"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Button = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Button"));

var _A = _interopRequireDefault(require("@bootstrap-styled/v4/lib/A"));

var _hover = require("@bootstrap-styled/css-mixins/lib/hover");

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-toolbar-button-padding': '2px',
      '$rsg-toolbar-button-color': '#292b2c',
      '$rsg-toolbar-button-background': 'transparent',
      '$rsg-toolbar-button-transition': 'color 750ms ease-out',
      '$rsg-toolbar-button-cursor': 'pointer',
      '$rsg-toolbar-button-hover-focus-isolation': 'false',
      '$rsg-toolbar-button-hover-focus-color': '#B31255',
      '$rsg-toolbar-button-hover-focus-transition': 'color 150ms ease-in',
      '$rsg-toolbar-button-focus-isolation': 'false',
      '$rsg-toolbar-button-focus-outline': '1 dotted #B31255',
      '$rsg-toolbar-button-children-isolation': 'false',
      '$rsg-toolbar-button-children-margin-left': '8px',
      '$rsg-toolbar-button-svg-width': '24px',
      '$rsg-toolbar-button-svg-height': '24px',
      '$rsg-toolbar-button-svg-color': '#CCCCCC',
      '$rsg-toolbar-button-svg-cursor': 'inherit',
      '$rsg-toolbar-button-small-width': '14px',
      '$rsg-toolbar-button-small-height': '14px'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Set href to `<A />` component. */
  href: _propTypes.default.string,

  /** Set function passed to onclick button event. */
  onClick: _propTypes.default.func,

  /** Set href to `<A />` or`<Button />` component. */
  title: _propTypes.default.string,

  /** Toggle small style. */
  small: _propTypes.default.bool,

  /** Specified node element will be passed as children of `<ToolbarButtonRenderer />` component. */
  children: _propTypes.default.node,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-toolbar-button-padding': _propTypes.default.string,
      '$rsg-toolbar-button-color': _propTypes.default.string,
      '$rsg-toolbar-button-background': _propTypes.default.string,
      '$rsg-toolbar-button-transition': _propTypes.default.string,
      '$rsg-toolbar-button-cursor': _propTypes.default.string,
      '$rsg-toolbar-button-hover-focus-isolation': _propTypes.default.string,
      '$rsg-toolbar-button-hover-focus-color': _propTypes.default.string,
      '$rsg-toolbar-button-hover-focus-transition': _propTypes.default.string,
      '$rsg-toolbar-button-focus-isolation': _propTypes.default.string,
      '$rsg-toolbar-button-focus-outline': _propTypes.default.string,
      '$rsg-toolbar-button-children-isolation': _propTypes.default.string,
      '$rsg-toolbar-button-children-margin-left': _propTypes.default.string,
      '$rsg-toolbar-button-svg-width': _propTypes.default.string,
      '$rsg-toolbar-button-svg-height': _propTypes.default.string,
      '$rsg-toolbar-button-svg-color': _propTypes.default.string,
      '$rsg-toolbar-button-svg-cursor': _propTypes.default.string,
      '$rsg-toolbar-button-small-width': _propTypes.default.string,
      '$rsg-toolbar-button-small-height': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var ToolbarButtonRendererUnstyled = function ToolbarButtonRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      onClick = _omit.onClick,
      href = _omit.href,
      title = _omit.title,
      small = _omit.small,
      children = _omit.children,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "onClick", "href", "title", "small", "children", "cssModule"]);

  var classNames = (0, _lib.default)((0, _classnames.default)(className, 'rsg-toolbar-button no-print', small && 'small'), cssModule);

  if (href !== undefined) {
    return _react.default.createElement(_A.default, (0, _extends2.default)({
      href: href,
      title: title,
      className: classNames,
      "aria-label": title
    }, attributes), children);
  }

  return _react.default.createElement(_Button.default, (0, _extends2.default)({
    onClick: onClick,
    title: title,
    className: classNames,
    "aria-label": title
  }, attributes), children);
};

ToolbarButtonRendererUnstyled.defaultProps = defaultProps;
ToolbarButtonRendererUnstyled.propTypes = propTypes;
var ToolbarButtonRenderer = (0, _styledComponents.default)(ToolbarButtonRendererUnstyled).withConfig({
  displayName: "ToolbarButtonRenderer",
  componentId: "ysmcic-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-toolbar-button {\n      padding: ".concat(props.theme.styleguide['$rsg-toolbar-button-padding'], ";\n      color: ").concat(props.theme.styleguide['$rsg-toolbar-button-color'], ";\n      background: ").concat(props.theme.styleguide['$rsg-toolbar-button-background'], ";\n      transition: ").concat(props.theme.styleguide['$rsg-toolbar-button-transition'], ";\n      cursor: ").concat(props.theme.styleguide['$rsg-toolbar-button-cursor'], ";\n  ").concat((0, _hover.hoverFocus)(props.theme['$enable-hover-media-query'], "\n      isolation: ".concat(props.theme.styleguide['$rsg-toolbar-button-hover-focus-isolation'], ";\n      color: ").concat(props.theme.styleguide['$rsg-toolbar-button-hover-focus-color'], ";\n      transition: ").concat(props.theme.styleguide['$rsg-toolbar-button-hover-focus-transition'], ";\n    ")), "\n      &:focus {\n        isolation: ").concat(props.theme.styleguide['$rsg-toolbar-button-focus-isolation'], ";\n        outline: ").concat(props.theme.styleguide['$rsg-toolbar-button-focus-outline'], ";\n      }\n      & + & {\n        isolation: ").concat(props.theme.styleguide['$rsg-toolbar-button-children-isolation'], ";\n        margin-left: ").concat(props.theme.styleguide['$rsg-toolbar-button-children-margin-left'], ";\n      }\n      &:i {\n        z-index: 1200;\n        width: ").concat(props.theme.styleguide['$rsg-toolbar-button-svg-width'], ";\n        height: ").concat(props.theme.styleguide['$rsg-toolbar-button-svg-height'], ";\n        color: ").concat(props.theme.styleguide['$rsg-toolbar-button-svg-color'], ";\n        cursor: ").concat(props.theme.styleguide['$rsg-toolbar-button-svg-cursor'], ";\n      }\n    }\n    &.toolbar-button .small {\n      &:i {\n        width: ").concat(props.theme.styleguide['$rsg-toolbar-button-small-width'], ";\n        height: ").concat(props.theme.styleguide['$rsg-toolbar-button-small-height'], ";\n      }\n    }\n ");
});
ToolbarButtonRenderer.defaultProps = defaultProps;
ToolbarButtonRenderer.propTypes = propTypes;
/** @component */

var _default = ToolbarButtonRenderer;
exports.default = _default;