"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Code = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Code"));

var _breakpoints = _interopRequireDefault(require("@bootstrap-styled/css-mixins/lib/breakpoints"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-type-font-size': {
        xs: '12px',
        sm: '15px'
      },
      '$rsg-type-color': '#75096a'
    }
  }
};
exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Specified node element will be passed as children of `<TypeRenderer />` component. */
  children: _propTypes.default.node.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-type-font-size': _propTypes.default.shape({
        xs: _propTypes.default.string,
        sm: _propTypes.default.string
      }),
      '$rsg-type-color': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
exports.propTypes = propTypes;

var TypeRendererUnstyled = function TypeRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "cssModule"]);

  return _react.default.createElement("span", (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-type'), cssModule)
  }, attributes), _react.default.createElement(_Code.default, {
    className: "type-renderer-code"
  }, children));
};

TypeRendererUnstyled.defaultProps = defaultProps;
TypeRendererUnstyled.propTypes = propTypes;
var TypeRenderer = (0, _styledComponents.default)(TypeRendererUnstyled).withConfig({
  displayName: "TypeRenderer",
  componentId: "sc-192ns6n-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-type {\n      .type-renderer-code {\n  ".concat(_breakpoints.default.up('xs', props.theme['$grid-breakpoints'], "\n      font-size: ".concat(props.theme.styleguide['$rsg-type-font-size'].xs, " !important;\n    ")), "\n  ").concat(_breakpoints.default.up('sm', props.theme['$grid-breakpoints'], "\n     font-size: ".concat(props.theme.styleguide['$rsg-type-font-size'].sm, " !important;\n    ")), "\n        color: ").concat(props.theme.styleguide['$rsg-type-color'], " !important;\n      }\n    }\n ");
});
TypeRenderer.defaultProps = defaultProps;
TypeRenderer.propTypes = propTypes;
/** @component */

var _default = TypeRenderer;
exports.default = _default;