"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Usage;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.isempty"));

var _Props = _interopRequireDefault(require("react-styleguidist/lib/rsg-components/Props"));

var _Methods = _interopRequireDefault(require("../Methods"));

function Usage(_ref) {
  var _ref$props = _ref.props,
      props = _ref$props.props,
      methods = _ref$props.methods;

  var propsNode = !(0, _lodash.default)(props) && _react.default.createElement(_Props.default, {
    props: props
  });

  var methodsNode = !(0, _lodash.default)(methods) && _react.default.createElement(_Methods.default, {
    methods: methods
  });

  if (!propsNode && !methodsNode) {
    return null;
  }

  return _react.default.createElement("div", {
    className: "rsg-usage"
  }, propsNode, methodsNode);
}

Usage.propTypes = {
  /** Properties to be rendered in properties table. Can be: */
  props: _propTypes.default.shape({
    props: _propTypes.default.array,
    methods: _propTypes.default.array
  }).isRequired
};
module.exports = exports.default;