"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var _P = _interopRequireDefault(require("@bootstrap-styled/v4/lib/P"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-version-color': 'lightgray',
      '$rsg-version-margin': '0',
      '$rsg-version-font-family': 'inherit',
      '$rsg-version-font-size': '15px'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /**
   * @ignore
   */
  children: _propTypes.default.node,
  // eslint-disable-line react/require-default-props

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-version-color': _propTypes.default.string,
      '$rsg-version-margin': _propTypes.default.string,
      '$rsg-version-font-family': _propTypes.default.string,
      '$rsg-version-font-size': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var VersionRendererUnstyled = function VersionRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "cssModule"]);

  return _react.default.createElement(_P.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-version'), cssModule),
    "aria-label": "version"
  }, attributes), children);
};

VersionRendererUnstyled.defaultProps = defaultProps;
VersionRendererUnstyled.propTypes = propTypes;
var VersionRenderer = (0, _styledComponents.default)(VersionRendererUnstyled).withConfig({
  displayName: "VersionRenderer",
  componentId: "qwsctz-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-version {\n    color: ".concat(props.theme.styleguide['$rsg-version-color'], ";\n    margin: ").concat(props.theme.styleguide['$rsg-version-margin'], ";\n    font-family: ").concat(props.theme.styleguide['$rsg-version-font-family'], ";\n    font-size: ").concat(props.theme.styleguide['$rsg-version-font-size'], ";\n    }\n ");
});
VersionRenderer.defaultProps = defaultProps;
VersionRenderer.propTypes = propTypes;
/** @component */

var _default = VersionRenderer;
exports.default = _default;