"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _consts = require("react-styleguidist/scripts/consts");

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Markdown = _interopRequireDefault(require("../Markdown"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-welcome-max-width': '1000',
      '$rsg-welcome-margin': '0 auto',
      '$rsg-welcome-padding': '32px'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-welcome-max-width': _propTypes.default.string,
      '$rsg-welcome-margin': _propTypes.default.string,
      '$rsg-welcome-padding': _propTypes.default.string
    })
  }),

  /** Set patterns used in welcome example. */
  patterns: _propTypes.default.array.isRequired,

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var WelcomeRendererUnstyled = function WelcomeRendererUnstyled(props, _ref) {
  var config = _ref.config;

  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      patterns = _omit.patterns,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "patterns", "cssModule"]);

  return _react.default.createElement("div", (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-welcome'), cssModule)
  }, attributes), _react.default.createElement(_Markdown.default, {
    text: "\n# Welcome to ".concat(config.title, "!\n\n**We couldn\u2019t find any components** using these patterns:\n\n").concat(patterns.map(function (p) {
      return "- `".concat(p, "`");
    }).join('\n'), "\n\nCreate **styleguide.config.js** file in your project root directory like this:\n\n    module.exports = {\n      components: 'src/components/**/*.js'\n    };\n\nRead more in the [locating components guide](").concat(_consts.DOCS_COMPONENTS, ").\n        ")
  }));
};

WelcomeRendererUnstyled.defaultProps = defaultProps;
WelcomeRendererUnstyled.propTypes = propTypes;
WelcomeRendererUnstyled.contextTypes = {
  config: _propTypes.default.object
};
var WelcomeRenderer = (0, _styledComponents.default)(WelcomeRendererUnstyled).withConfig({
  displayName: "WelcomeRenderer",
  componentId: "sc-16b5rk6-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-welcome {\n      max-width: ".concat(props.theme.styleguide['$rsg-welcome-max-width'], ";\n      margin: ").concat(props.theme.styleguide['$rsg-welcome-margin'], ";\n      padding: ").concat(props.theme.styleguide['$rsg-welcome-padding'], ";\n    }\n ");
});
WelcomeRenderer.defaultProps = defaultProps;
WelcomeRenderer.propTypes = propTypes;
WelcomeRendererUnstyled.contextTypes = {
  config: _propTypes.default.object
};
/** @component */

var _default = WelcomeRenderer;
exports.default = _default;