"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _Wrapper = _interopRequireDefault(require("../Wrapper"));

it('should render children', function () {
  var children = _react.default.createElement("span", null, "Hello");

  var actual = (0, _enzyme.shallow)(_react.default.createElement(_Wrapper.default, {
    onError: function onError() {}
  }, children));
  expect(actual).toMatchSnapshot();
});
it('should call onError handler when React invokes error handler', function () {
  var onError = jest.fn();
  var actual = (0, _enzyme.shallow)(_react.default.createElement(_Wrapper.default, {
    onError: onError
  }, "blah")); // faux error

  actual.instance().componentDidCatch('err');
  expect(onError).toHaveBeenCalledTimes(1);
  expect(onError).toHaveBeenCalledWith('err');
});